<?php
/**********************************************************************************
* ForumFirewall-Admin.php - PHP template for ForumFirewall mod
* Version 2.0.0 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

if (!defined('SMF')) die('Hacking attempt...');

// Admin initializer
function forumfirewall_admin_init($return_config = false) {
	global $txt, $scripturl, $context, $settings, $sc, $modSettings;
	global $smcFunc, $sourcedir, $user_info, $ffcachedir, $boarddir;

	require_once($sourcedir . DIRECTORY_SEPARATOR .'ManageMembers.php');
	require_once($sourcedir . DIRECTORY_SEPARATOR .'Security.php');
	if (!function_exists('timeformat'))
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs.php');

	$ftest = '';
	$ftest = file_exists($boarddir . DIRECTORY_SEPARATOR . 'ffcache');
	if (empty($ftest)) $ftest = @is_dir($ffcachedir);
	if (empty($ftest)) {
		 if (strtolower(@ini_get('safe_mode')) != 'on' || strtolower(@ini_get('safe_mode')) != 'yes' || strtolower(@ini_get('safe_mode')) != 'true' || @ini_get("safe_mode") != 1 )
			$ftest = exec(escapeshellcmd("ls ".$ffcachedir));	}
	if (empty($ftest)) {
			if (function_exists('loadlanguage')) {
				if(loadlanguage('Errors') === false)
   		  		 	loadLanguage('Errors');
			} else {
				require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
				if(loadlanguage('Errors') === false)
   		   			loadLanguage('Errors'); }

		log_error($txt['cfcachef'], 'user');
	}

	if (empty($_REQUEST['sa']))
		$_REQUEST['sa'] = '';

	$config_vars = array(
	);

	if ($return_config)
		return $config_vars;

	isAllowedTo('admin_forum');

	 loadTemplate('ForumFirewall_Admin');
	 loadLanguage('ForumFirewall');

	$context['html_headers'] .= '
		<link rel="stylesheet" type="text/css" href="' . $settings['theme_url'] . '/css/forumfirewall.css?rc3" />';
	$context['sub_template'] = 'show_settings';
	$context['page_title'] = $txt['forumfirewall_config'];
	$context['sub_action'] = $_REQUEST['sa'];
	$context['settings_message'] = '<br /><div class="forumfirewall_fail">' . forumfirewall_inspect_system() . '</div><br />';

	if (empty($context['character_set'])) {  //  Need this for template
	// Set the character set from the template.
		$context['character_set'] = empty($modSettings['global_character_set']) ? $txt['lang_character_set'] : $modSettings['global_character_set'];
		$context['utf8'] = $context['character_set'] === 'UTF-8' && (strpos(strtolower(PHP_OS), 'win') === false || @version_compare(PHP_VERSION, '4.2.3') != -1);
	}

	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => &$txt['forumfirewall_admin'],
		'description' => $txt['forumfirewall_admin_desc'],
		'tabs' => array(
			'forumfirewall_settings' => array(
				'description' => $txt['forumfirewall_settings_desc'],
				'href' => $scripturl . '?action=admin;area=forumfirewall;sa=settings',
				'is_selected' => $_REQUEST['sa'] == 'forumfirewall_settings',
			),
			'forumfirewall_report_denied' => array(
				'description' => $txt['forumfirewall_reports_desc'],
				'href' => $scripturl . '?action=admin;area=forumfirewall;sa=forumfirewall_report_denied',
				'is_selected' => $_REQUEST['sa'] == 'forumfirewall_report_denied',
			),
			'forumfirewall_challenge_report' => array(
				'description' => $txt['forumfirewall_challenge_report_desc'],
				'href' => $scripturl . '?action=admin;area=forumfirewall;sa=forumfirewall_challenge_report',
				'is_selected' => $_REQUEST['sa'] == 'forumfirewall_challenge_report',
			),
			'forumfirewall_about' => array(
				'description' => $txt['forumfirewall_about_desc'],
				'href' => $scripturl . '?action=admin;area=forumfirewall;sa=about',
				'is_selected' => $_REQUEST['sa'] == 'forumfirewall_about',
			),
		),
	);

	$subActions = array(
		'forumfirewall_settings' => 'forumfirewall_admin_settings',
		'forumfirewall_report_denied' => 'forumfirewall_admin_reports',
		'forumfirewall_challenge_report' => 'forumfirewall_admin_challenge',
		'forumfirewall_about' => 'forumfirewall_admin_about',
	);

	// By default go to the settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'forumfirewall_settings';

	// Call the function for the sub-acton.
	$subActions[$_REQUEST['sa']]();
}

function forumfirewall_admin_settings($return_config = false)
{
	global $smcFunc, $txt, $scripturl, $context, $sourcedir, $modSettings, $db_prefix;

	isAllowedTo('admin_forum');

	require_once($sourcedir. DIRECTORY_SEPARATOR . 'ManageServer.php');

	loadLanguage('ForumFirewall');

	if ($modSettings['forumfirewall_domain'] == 'www.yourdomain.com')
		$modSettings['forumfirewall_enable_bypass'] = '0';

	if ($modSettings['forumfirewall_ip'] == '00.00.00.00')
		$modSettings['forumfirewall_enable_bypass'] = '0';

	if (!empty($modSettings['forumfirewall_real_ip']))
			if (stripos(ff_StrFmt_callback($modSettings['forumfirewall_real_ip']), 'Http-') !== 0)
				$modSettings['forumfirewall_real_ip'] = 'HTTP_' . $modSettings['forumfirewall_real_ip'];

	$config_vars = array(
	    '',
		$txt['forumfirewall_general'],
	    '',
		array('check', 'forumfirewall_enable'),
		array('check', 'forumfirewall_enable_block'),
		array('check', 'forumfirewall_logging'),
		array('int', 'forumfirewall_cache_duration', '2', 'forumfirewall_cache_duration'),
		array('text', 'forumfirewall_salt'),
		array('select', 'forumfirewall_enable_email', array(&$txt['forumfirewall_email_diabled_0'], &$txt['forumfirewall_email_ddos_1'], &$txt['forumfirewall_email_all_2'])),
	    '',
		$txt['forumfirewall_dos_attack'],
	    '',
		array('check', 'forumfirewall_enable_ua'),
		array('check', 'forumfirewall_enable_dos'),
		array('large_text', 'forumfirewall_good_ua'),
		array('text', 'forumfirewall_trigger'),
		array('select', 'forumfirewall_longterm_ban', array(&$txt['forumfirewall_never_0'], &$txt['forumfirewall_1hr_1'], &$txt['forumfirewall_24hr_2'], &$txt['forumfirewall_1wk_3'], &$txt['forumfirewall_permanent_4'])),
	    '',
		$txt['forumfirewall_ip_title'],
	    '',
		array('check', 'forumfirewall_enable_check_ip'),
		array('check', 'forumfirewall_enable_proxy'),
		array('check', 'forumfirewall_enable_challenge', 'disabled' => (strnatcmp(phpversion(),'5.2.0') < 0)),
		array('check', 'forumfirewall_enable_admin'),
		array('text', 'forumfirewall_admin_ip_lo','29'),
		array('text', 'forumfirewall_admin_ip_hi','29'),
		array('text', 'forumfirewall_admin_domain'),
	    '',
		$txt['forumfirewall_robots_title'],
	    '',
		array('check', 'forumfirewall_enable_robots'),
		array('large_text', 'forumfirewall_test_robots'),
		array('large_text', 'forumfirewall_robotstxt_action'),
	    '',
		$txt['forumfirewall_port_title'],
	    '',
		array('check', 'forumfirewall_enable_rmtport'),
		array('check', 'forumfirewall_enable_svrport'),
		array('text', 'forumfirewall_good_ser_ports'),
	    '',
		$txt['forumfirewall_injection'],
	    '',
		array('check', 'forumfirewall_enable_inj'),
		array('large_text', 'forumfirewall_uri_chars'),
		array('large_text', 'forumfirewall_exploits'),
	    '',
		$txt['forumfirewall_cookie'],
	    '',
		array('check', 'forumfirewall_enable_xxs'),
		array('large_text', 'forumfirewall_xxs'),
	    '',
		$txt['forumfirewall_header'],
	    '',
		array('check', 'forumfirewall_enable_header'),
		array('large_text', 'forumfirewall_referer_attack'),
		array('large_text', 'forumfirewall_ua_attack'),
		array('large_text', 'forumfirewall_entity_attack'),
	    '',
		$txt['forumfirewall_country'],
	    '',
		array('check', 'forumfirewall_enable_country'),
		array('check', 'forumfirewall_challenge_country', 'disabled' => (strnatcmp(phpversion(),'5.2.0') < 0)),
		array('check', 'forumfirewall_in_geoip'),
		array('text', 'forumfirewall_country_id'),
		array('large_text', 'forumfirewall_bad_countries'),
	    '',
		$txt['forumfirewall_bypass'],
	    '',
		array('text', 'forumfirewall_real_ip', '25'),
		array('text', 'forumfirewall_header_id'),
		array('check', 'forumfirewall_enable_bypass'),
		array('text', 'forumfirewall_domain', '32'),
		array('text', 'forumfirewall_ip','29'),
		);

	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl .'?action=admin;area=forumfirewall;save;sa=settings';
	$context['page_title'] = $txt['forumfirewall_settings_sub'];
	loadTemplate('ForumFirewall_Admin');
	$context['sub_template'] = 'show_settings';

	if (isset($_GET['save'])) {
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=forumfirewall');
	}

	prepareDBSettingContext($config_vars);
}


function forumfirewall_admin_about() {
	global $txt, $context;

	isAllowedTo('admin_forum');

	$context['sub_template'] = 'forumfirewall_about';
	$context['page_title'] = $txt['forumfirewall_about_title'];

}

function forumfirewall_admin_reports() {
	global $smcFunc, $context, $txt, $page_num, $scripturl;

	isAllowedTo('admin_forum');

	if (empty($_REQUEST['ffid']))
		$_REQUEST['ffid'] = '';

	$context['ffid'] = $_REQUEST['ffid'];

	if ($context['ffid'] != '')
		forumfirewall_event();
	else {
		$sort_columns = array(
			'ip' => 'ip',
			'date' => 'date',
			'result' => 'result',
		); //  header and reason

	$page_num = 0;
	$per_page = 30;

	if ($context['sub_action'] == 'forumfirewall_report_denied')
		$where = "cf.id >= 0";
	else
		$where = "cf.id >= 0";

	$_REQUEST['start'] = empty($_REQUEST['start']) || $_REQUEST['start'] < 0 ? 0 : (int) $_REQUEST['start'];

	if (empty($_REQUEST['sort_by']) || !isset($sort_columns[$_REQUEST['sort_by']])) {
		$_REQUEST['sort_by'] = 'date';
		$_REQUEST['desc'] = true; }

	$context['order_by'] = isset($_REQUEST['desc']) ? 'down' : 'up';
	$context['sort_by'] = $_REQUEST['sort_by'];

	$context['start'] = $_REQUEST['start'];

	$sort_by = $sort_columns[$context['sort_by']];
	$order_by = (isset($_REQUEST['desc']) ? ' desc' : 'asc');

	if (isset($_POST['ff_dellog'])) ff_truncate_log();

		$result = forumfirewall_db_manage($where, $page_num, $per_page, $sort_by, $order_by);

		$context['page_index'] = constructPageIndex($scripturl . '?action=admin;area=forumfirewall;sa='.$context['sub_action'].';sort_by=' . $context['sort_by']. ($context['order_by'] == 'down' ? ';desc' : ''), $_REQUEST['start'], $context['cf_per_page'], $per_page);

		$page_num = $result[3];

		$context['sub_template'] = 'forumfirewall_reports';
	}

	$context['description'] = $txt['forumfirewall_reports_desc'];

	if ($context['sub_action'] == 'forumfirewall_report_denied')
		$context['settings_title'] = $txt['forumfirewall_report_denied_title'];
}

function forumfirewall_db_manage($where = "cf.id >= 0", $page_num=1, $per_page=5, $sort_by='date', $order_by='desc') {

	isAllowedTo('admin_forum');

	global $smcFunc, $context;

	$limit_start = '';
	$context['forumfirewall_log'] = array();
	
	if ($page_num < 1)
		$page_num = 1;
	if ($per_page < 1)
		$per_page = 1;
  if ($sort_by !== 'ip' && $sort_by !== 'date' && $sort_by !== 'result')
		$sort_by='date';
	if ($order_by !== 'asc' && $order_by !== 'desc')
		$order_by='desc';

	$total_result = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}log_forumfirewall AS cf
		WHERE ' . $where,
		array(
		)
	);

	list ($total_count) = $smcFunc['db_fetch_row']($total_result);
	$smcFunc['db_free_result']($total_result);

	$limit_start = (isset($context['start'])? $context['start'] : ($limit_start = ($page_num * $per_page) - $per_page));
	if ($limit_start > $total_count)
		$limit_start = $total_count-1;

	if ($per_page > $total_count)
		$per_page = $total_count;
	
	$limit_end = $limit_start + $per_page;
	
	if ($limit_end > $total_count)
		$limit_end = $total_count;

	//Make sure the page number requested actually exists
	for ($i = $page_num; $i > 1; $i--) {
		if ((($page_num * $per_page) - $per_page) > $total_count)
			$page_num--; }

	$qresult = $smcFunc['db_query']('', '
		SELECT *
		FROM {db_prefix}log_forumfirewall AS cf
		WHERE ' . $where . '
		ORDER BY {identifier:sort} {raw:order}
		LIMIT {int:offset}, {int:items_per_page}',
		array(
			'sort' => $sort_by,
			'order' => $order_by,
			'offset' => $limit_start,
			'items_per_page' => $per_page,
		)
	);

	while($row = $smcFunc['db_fetch_assoc']($qresult)) {

		//This field can be blank alot, so put a space in it.
		if (empty($row['request_entity']))
			$row['request_entity'] = '&nbsp;';

		//  Load DB into array
		$context['forumfirewall_log'][] = array(
			'ffid'  => $row['id'],
			'ip'  => forumfirewall_bin2ip(forumfirewall_DB2bin($row['ip'])),
			'date'  => timeformat((int) $row['date']),
			'http_headers'  => $row['http_headers'],
			'result'  => $row['result'],
		);
	}

	$smcFunc['db_free_result']($qresult);

    $limit_start++;	

	$context['cf_where'] = $limit_start;
	$context['cf_page_num'] = $limit_end;
	$context['cf_per_page'] = $total_count;

	$return_array = array($limit_start, $limit_end, $total_count, $page_num);

	return $return_array;
}

function forumfirewall_event() {
	isAllowedTo('admin_forum');

	global $context, $smcFunc;

	$type = $where = '';

	$context['ffid'] = $_REQUEST['ffid'];

	$where = "cf.id = {int:selected_id}";

	$qresult = $smcFunc['db_query']('', '
		SELECT *
		FROM {db_prefix}log_forumfirewall AS cf
		WHERE ' . $where,
		array(
			'selected_id' => $context['ffid'],
		)
	);
	// ip below was (empty($row['ip']) ? '' : $row['ip'],
	$row = $smcFunc['db_fetch_assoc']($qresult);
		
		$context['forumfirewall_log'][] = array(
			'ffid'  => $row['id'],
			'ip'  => (empty($row['ip']) ? '' : $row['ip']),
			'date'  => timeformat((int) $row['date']),
			'http_headers'  => htmlspecialchars($row['http_headers']),
			'result'  => $row['result'],
		);

	$smcFunc['db_free_result']($qresult);

	$context['sub_template'] = 'forumfirewall_event';
}

function forumfirewall_admin_challenge() {
	global $smcFunc, $context, $txt, $page_num, $scripturl;

	isAllowedTo('admin_forum');

	$sort_columns = array(
		'ip' => 'ip',
		'date' => 'date',
		'result' => 'result',
	); //  header and reason

	$page_num = 0;
	$per_page = 30;

	$where = "cff.id >= 0";

	$_REQUEST['start'] = empty($_REQUEST['start']) || $_REQUEST['start'] < 0 ? 0 : (int) $_REQUEST['start'];

	if (empty($_REQUEST['sort_by']) || !isset($sort_columns[$_REQUEST['sort_by']])) {
		$_REQUEST['sort_by'] = 'date';
		$_REQUEST['desc'] = true; }

	$context['order_by'] = isset($_REQUEST['desc']) ? 'down' : 'up';
	$context['sort_by'] = $_REQUEST['sort_by'];

	$context['start'] = $_REQUEST['start'];

	$sort_by = $sort_columns[$context['sort_by']];
	$order_by = (isset($_REQUEST['desc']) ? ' desc' : 'asc');

	if (isset($_POST['ff_delchal'])) ff_truncate_challenges();

	$result = forumfirewall_db_challenge($where, $page_num, $per_page, $sort_by, $order_by);

	$context['page_index'] = constructPageIndex($scripturl . '?action=admin;area=forumfirewall;sa='.$context['sub_action'].';sort_by=' . $context['sort_by']. ($context['order_by'] == 'down' ? ';desc' : ''), $_REQUEST['start'], $context['cff_per_page'], $per_page);

	$page_num = $result[3];

	$context['sub_template'] = 'forumfirewall_challenges';

	$context['description'] = $txt['forumfirewall_challenge_report_desc'];

	if ($context['sub_action'] == 'forumfirewall_challenge_report')
		$context['settings_title'] = $txt['forumfirewall_challenge_report_title'];
}

function forumfirewall_db_challenge($where = "cff.id >= 0", $page_num=1, $per_page=5, $sort_by='date', $order_by='desc') {

	isAllowedTo('admin_forum');

	global $smcFunc, $context;

	$limit_start = '';
	$context['forumfirewall_clog'] = array();
	
	if ($page_num < 1)
		$page_num = 1;
	if ($per_page < 1)
		$per_page = 1;
  if ($sort_by !== 'ip' && $sort_by !== 'date' && $sort_by !== 'result')
		$sort_by='date';
	if ($order_by !== 'asc' && $order_by !== 'desc')
		$order_by='desc';

	$total_result = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}log_ff_challenges AS cff
		WHERE ' . $where,
		array(
		)
	);

	list ($total_count) = $smcFunc['db_fetch_row']($total_result);
	$smcFunc['db_free_result']($total_result);

	$limit_start = (isset($context['start'])? $context['start'] : ($limit_start = ($page_num * $per_page) - $per_page));
	if ($limit_start > $total_count)
		$limit_start = $total_count-1;

	if ($per_page > $total_count)
		$per_page = $total_count;
	
	$limit_end = $limit_start + $per_page;
	
	if ($limit_end > $total_count)
		$limit_end = $total_count;

	//Make sure the page number requested actually exists
	for ($i = $page_num; $i > 1; $i--) {
		if ((($page_num * $per_page) - $per_page) > $total_count) {
			$page_num--; } }

	$qresult = $smcFunc['db_query']('', '
		SELECT *
		FROM {db_prefix}log_ff_challenges AS cff
		WHERE ' . $where . '
		ORDER BY {identifier:sort} {raw:order}
		LIMIT {int:offset}, {int:items_per_page}',
		array(
			'sort' => $sort_by,
			'order' => $order_by,
			'offset' => $limit_start,
			'items_per_page' => $per_page,
		)
	);

	while($row = $smcFunc['db_fetch_assoc']($qresult)) {

		//This field can be blank alot, so put a space in it.
		if (empty($row['request_entity']))
			$row['request_entity'] = '&nbsp;';

		//  Load DB into array
		$context['forumfirewall_clog'][] = array(
			'ffcid'  => $row['id'],
			'ip'  => forumfirewall_bin2ip(forumfirewall_DB2bin($row['ip'])),
			'date'  => timeformat((int) $row['date']),
			'result'  => $row['result'],
		);
	}

	$smcFunc['db_free_result']($qresult);

    $limit_start++;	

	$context['cff_where'] = $limit_start;
	$context['cff_page_num'] = $limit_end;
	$context['cff_per_page'] = $total_count;

	$return_array = array($limit_start, $limit_end, $total_count, $page_num);

	return $return_array;
}
// varbinary from the DB to bin
function forumfirewall_DB2bin($forumfirewall_ipBin) {

	isAllowedTo('admin_forum');
	if ($forumfirewall_ipBin == '') return '';  //  ????
	$ipbin = $bits = $forumfirewall_ip = '';
	$forumfirewall_unpack = Array();

	$forumfirewall_ip = forumfirewall_dtr_ntop($forumfirewall_ipBin);

	if (forumfirewall_IPv4orIPv6($forumfirewall_ip) === false)
        return sprintf('%032b', ip2long($forumfirewall_ip)); // base_convert(ip2long($forumfirewall_ip),10,2) 

	$forumfirewall_ip = forumfirewall_uncomip6($forumfirewall_ip);

    if(($forumfirewall_unpack = forumfirewall_dtr_pton($forumfirewall_ip)) === false) return false;
    $bits = 15; // 16 x 8 bit = 128bit (ipv6)
    while ($bits >= 0) {
        $forumfirewall_bin = sprintf('%08b',(ord($forumfirewall_unpack[$bits])));
        $ipbin = $forumfirewall_bin.$ipbin;
        $bits--;
    }

    return $ipbin;
}
function hextobin($hexstr) {
	isAllowedTo('admin_forum'); 

	$n = strlen($hexstr);
	$sbin = '';  
	$i = 0;
	while($i < $n) {      
		$a = substr($hexstr,$i,2);          
		$c = pack('H*', $a);
		if ($i == 0)
			$sbin = $c;
		else
			$sbin.=$c;

		$i += 2;
	}
	return $sbin;
}
//  Converts an IPv6 address from Binary into Hex representation.
function forumfirewall_bin2ip($forumfirewall_ipBin) {

	isAllowedTo('admin_forum'); 
	$forumfirewall_ip = '';

	$ff_strlen = strlen($forumfirewall_ipBin);

	if ((int) $ff_strlen < 128)
		return long2ip(bindec($forumfirewall_ipBin));

	$forumfirewall_part = forumfirewall_UTFstr_split($forumfirewall_ipBin, '16');
	foreach ($forumfirewall_part as $forumfirewall_parts) {
		$str = base_convert($forumfirewall_parts, 2, 16);
		$forumfirewall_ip .= $str.':';
	}
	unset($forumfirewall_parts);

	$forumfirewall_ip = substr($forumfirewall_ip, 0, -1);

	return $forumfirewall_ip;
}
// Converts an unpacked binary string saved into a printable IP ref http://www.highonphp.com/tag/inet_pton
function forumfirewall_dtr_ntop($forumfirewall_ipBin) { // version 2.0.0

	isAllowedTo('admin_forum');

	$ff_strlen = strlen($forumfirewall_ipBin);
	if(((int) $ff_strlen == 16) || ((int) $ff_strlen == 4)) {
		//  IPv6 & old IPv4 (len = 4 not used)
        return forumfirewall_inet_ntop(pack('A'.(int) $ff_strlen, $forumfirewall_ipBin));
    } else  //  ff_strlen = 32
		return long2ip(bindec($forumfirewall_ipBin));  //  IPv4

    return false;
}
// Converts a packed internet address to a human readable representation
// ref http://forums.phpfreaks.com/topic/242252-php-mysql-select-varbinery-field-output-wrong/
function forumfirewall_inet_ntop($ff_in_addr) { // version ipv6 only

	isAllowedTo('admin_forum');
	// in case mbstring overloads strlen function

	$forumfirewall_ip = '';

	switch ((int) (strlen($ff_in_addr))) {
		case 4:
			// IPv4 address
			$ff_prefix = '';
			list(,$ff_in_addr) = unpack('N',$ff_in_addr);
			$forumfirewall_ip = long2ip($ff_in_addr);
			break;

		case 16:
			$forumfirewall_ip = bin2hex($ff_in_addr);
			// IPv4-mapped address
			if(substr_compare($forumfirewall_ip, '00000000000000000000ffff', 0, 24) === 0) {
				$ff_prefix = '::ffff:';
				$forumfirewall_ip = substr($forumfirewall_ip, 24);
				break;
			}

			// IPv4-compat address
			if(substr_compare($forumfirewall_ip, '000000000000000000000000', 0, 24) === 0 &&
				substr_compare($forumfirewall_ip, '0000', 24, 4) !== 0) {
				$ff_prefix = '::';
				$forumfirewall_ip = substr($forumfirewall_ip, 24);
				break;
			}

			$forumfirewall_ip = substr(forumfirewall_UTFChunk($forumfirewall_ip, 4, ':'), 0, -1);

			// compress leading zeros
			$forumfirewall_ip = preg_replace('/(^|:)0{1,3}/','$1', $forumfirewall_ip);

			// compress longest (and leftmost) consecutive group of zeros
			if(preg_match_all('/(?:^|:)(0(:|$))+/', $forumfirewall_ip, $ff_matches)) {
				$ff_longestMatch = 0;
				foreach($ff_matches[0] as $ff_aMatch)
				{
					if((int) (strlen($ff_aMatch)) > (int) (strlen($ff_longestMatch)))
						$ff_longestMatch = $ff_aMatch;
				}
				unset($ff_aMatch);
				$forumfirewall_ip = substr_replace($forumfirewall_ip, '::', strpos($forumfirewall_ip, $ff_longestMatch), strlen($ff_longestMatch));
			}

			return $forumfirewall_ip;
			break;
		default:
			return false;
			break;
	}

	return $ff_prefix . $forumfirewall_ip;
}
//  UTF safe binary str_split ref php.net
function forumfirewall_UTFstr_split($str, $l = 0) {

	isAllowedTo('admin_forum');
	if(mb_detect_encoding($str) == 'UTF-8') {
		if ($l > 0) {
			$ret = array();
			$len = mb_strlen($str, 'UTF-8');
			for ($i = 0; $i < $len; $i += $l) {
 				$ret[] = mb_substr($str, $i, $l, 'UTF-8');
 		}
			return $ret;
	}
		return preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
	} else {
		return str_split($str, $l);
}	}
//  UTF safe binary chunk_split ref php.net
function forumfirewall_UTFChunk($Text, $Len = 10, $End = '\r\n') { // version 2.0.0

	isAllowedTo('admin_forum');
	if(mb_detect_encoding($Text) == 'UTF-8') {
		return mb_convert_encoding(chunk_split(mb_convert_encoding($Text, 'KOI8-R', 'UTF-8'), $Len, $End), 'UTF-8', 'KOI8-R');
	} else
		return chunk_split($Text, $Len, $End);
}
function ff_truncate_log() {
	if (!function_exists('isAllowedTo')) return;
	isAllowedTo('admin_forum');

	global $smcFunc, $db_prefix;

	$smcFunc['db_query']('truncate_table', '
		TRUNCATE {db_prefix}log_forumfirewall',
		array(
		)
	);
}
function ff_truncate_challenges() {
	if (!function_exists('isAllowedTo')) return;
	isAllowedTo('admin_forum');
	global $smcFunc, $db_prefix;

	$smcFunc['db_query']('truncate_table', '
		TRUNCATE {db_prefix}log_ff_challenges',
		array(
		)
	);
}
function ff_TrackIP($memID = 0)
{
	// Can the user do this?
	isAllowedTo('admin_forum');

	global $user_profile, $scripturl, $txt, $user_info, $modSettings, $sourcedir;
	global $context, $smcFunc;

	if ($memID == 0) {
		$context['ip'] = $user_info['ip'];
		loadTemplate('Profile');
		loadLanguage('Profile');
		$context['sub_template'] = 'trackIP';
		$context['page_title'] = $txt['profile'];
		$context['base_url'] = $scripturl . '?action=trackip';
	} else {
		$context['ip'] = $user_profile[$memID]['member_ip'];
		$context['base_url'] = $scripturl . '?action=profile;area=tracking;sa=ip;u=' . $memID;
	}

	// Searching?
	if (isset($_REQUEST['searchip']))
		$context['ip'] = trim($_REQUEST['searchip']);

	$context['ip'] = forumfirewall_xss_safe($context['ip']);

	$ip_var = str_replace('*', '%', $context['ip']);
	$ip_string = strpos($ip_var, '%') === false ? '= {string:ip_address}' : 'LIKE {string:ip_address}';

	if (empty($context['tracking_area']))
		$context['page_title'] = $txt['trackIP'] . ' - ' . $context['ip'];

	$request = $smcFunc['db_query']('', '
		SELECT id_member, real_name AS display_name, member_ip
		FROM {db_prefix}members
		WHERE member_ip ' . $ip_string,
		array(
			'ip_address' => $ip_var,
		)
	);
	$context['ips'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$context['ips'][$row['member_ip']][] = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['display_name'] . '</a>';
	$smcFunc['db_free_result']($request);

	ksort($context['ips']);

	// Gonna want this for the list.
	require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs-List.php');

	if (!function_exists('list_getIPMessageCount'))
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Profile-View.php');

	// Start with the user messages.
	$listOptions = array(
		'id' => 'track_message_list',
		'title' => $txt['messages_from_ip'] . ' ' . $context['ip'],
		'start_var_name' => 'messageStart',
		'items_per_page' => $modSettings['defaultMaxMessages'],
		'no_items_label' => $txt['no_messages_from_ip'],
		'base_href' => $context['base_url'] . ';searchip=' . $context['ip'],
		'default_sort_col' => 'date',
		'get_items' => array(
			'function' => 'list_getIPMessages',
			'params' => array(
				'm.poster_ip ' . $ip_string,
				array('ip_address' => $ip_var),
			),
		),
		'get_count' => array(
			'function' => 'list_getIPMessageCount',
			'params' => array(
				'm.poster_ip ' . $ip_string,
				array('ip_address' => $ip_var),
			),
		),
		'columns' => array(
			'ip_address' => array(
				'header' => array(
					'value' => $txt['ip_address'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<a href="' . $context['base_url'] . ';searchip=%1$s">%1$s</a>',
						'params' => array(
							'ip' => false,
						),
					),
				),
				'sort' => array(
					'default' => 'INET_ATON(m.poster_ip)',
					'reverse' => 'INET_ATON(m.poster_ip) DESC',
				),
			),
			'poster' => array(
				'header' => array(
					'value' => $txt['poster'],
				),
				'data' => array(
					'db' => 'member_link',
				),
			),
			'subject' => array(
				'header' => array(
					'value' => $txt['subject'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<a href="' . $scripturl . '?topic=%1$s.msg%2$s#msg%2$s" rel="nofollow">%3$s</a>',
						'params' => array(
							'topic' => false,
							'id' => false,
							'subject' => false,
						),
					),
				),
			),
			'date' => array(
				'header' => array(
					'value' => $txt['date'],
				),
				'data' => array(
					'db' => 'time',
				),
				'sort' => array(
					'default' => 'm.id_msg DESC',
					'reverse' => 'm.id_msg',
				),
			),
		),
		'additional_rows' => array(
			array(
				'position' => 'after_title',
				'value' => $txt['messages_from_ip_desc'],
				'class' => 'smalltext',
				'style' => 'padding: 2ex;',
			),
		),
	);

	// Create the messages list.
	createList($listOptions);

	// Set the options for the error lists.
	$listOptions = array(
		'id' => 'track_user_list',
		'title' => $txt['errors_from_ip'] . ' ' . $context['ip'],
		'start_var_name' => 'errorStart',
		'items_per_page' => $modSettings['defaultMaxMessages'],
		'no_items_label' => $txt['no_errors_from_ip'],
		'base_href' => $context['base_url'] . ';searchip=' . $context['ip'],
		'default_sort_col' => 'date2',
		'get_items' => array(
			'function' => 'list_getUserErrors',
			'params' => array(
				'le.ip ' . $ip_string,
				array('ip_address' => $ip_var),
			),
		),
		'get_count' => array(
			'function' => 'list_getUserErrorCount',
			'params' => array(
				'ip ' . $ip_string,
				array('ip_address' => $ip_var),
			),
		),
		'columns' => array(
			'ip_address2' => array(
				'header' => array(
					'value' => $txt['ip_address'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<a href="' . $context['base_url'] . ';searchip=%1$s">%1$s</a>',
						'params' => array(
							'ip' => false,
						),
					),
				),
				'sort' => array(
					'default' => 'INET_ATON(le.ip)',
					'reverse' => 'INET_ATON(le.ip) DESC',
				),
			),
			'display_name' => array(
				'header' => array(
					'value' => $txt['display_name'],
				),
				'data' => array(
					'db' => 'member_link',
				),
			),
			'message' => array(
				'header' => array(
					'value' => $txt['message'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '%1$s<br /><a href="%2$s">%2$s</a>',
						'params' => array(
							'message' => false,
							'url' => false,
						),
					),
				),
			),
			'date2' => array(
				'header' => array(
					'value' => $txt['date'],
				),
				'data' => array(
					'db' => 'time',
				),
				'sort' => array(
					'default' => 'le.id_error DESC',
					'reverse' => 'le.id_error',
				),
			),
		),
		'additional_rows' => array(
			array(
				'position' => 'after_title',
				'value' => $txt['errors_from_ip_desc'],
				'class' => 'smalltext',
				'style' => 'padding: 2ex;',
			),
		),
	);

	// Create the error list.
	createList($listOptions);

	$context['single_ip'] = strpos($context['ip'], '*') === false;
	if ($context['single_ip']) {
		$context['whois_servers'] = array(
			'afrinic' => array(
				'name' => $txt['whois_afrinic'],
				'url' => 'http://www.afrinic.net/cgi-bin/whois?searchtext=' . $context['ip'],
				'range' => array(41, 154, 196),
			),
			'apnic' => array(
				'name' => $txt['whois_apnic'],
				'url' => 'http://wq.apnic.net/apnic-bin/whois.pl?searchtext=' . $context['ip'],
				'range' => array(58, 59, 60, 61, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124,
					125, 126, 133, 150, 153, 163, 171, 202, 203, 210, 211, 218, 219, 220, 221, 222),
			),
			'arin' => array(
				'name' => $txt['whois_arin'],
				'url' => 'http://whois.arin.net/rest/ip/' . $context['ip'],
				'range' => array(7, 24, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 96, 97, 98, 99,
					128, 129, 130, 131, 132, 134, 135, 136, 137, 138, 139, 140, 142, 143, 144, 146, 147, 148, 149,
					152, 155, 156, 157, 158, 159, 160, 161, 162, 164, 165, 166, 167, 168, 169, 170, 172, 173, 174,
					192, 198, 199, 204, 205, 206, 207, 208, 209, 216),
			),
			'lacnic' => array(
				'name' => $txt['whois_lacnic'],
				'url' => 'http://lacnic.net/cgi-bin/lacnic/whois?query=' . $context['ip'],
				'range' => array(186, 187, 189, 190, 191, 200, 201),
			),
			'ripe' => array(
				'name' => $txt['whois_ripe'],
				'url' => 'https://apps.db.ripe.net/search/query.html?searchtext=' . $context['ip'],
				'range' => array(62, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
					141, 145, 151, 188, 193, 194, 195, 212, 213, 217),
			),
		);

		foreach ($context['whois_servers'] as $whois) {
			// Strip off the "decimal point" and anything following...
			if (in_array((int) $context['ip'], $whois['range']))
				$context['auto_whois_server'] = $whois;
}	}	}
?>