<?php
/**********************************************************************************
* ForumFirewall_Challenge.php- PHP class SMF 2.x for ForumFirewall mod
* Version 2.0.0 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/
//  *********   FUTURE ADD VERIFICATION QUESTIONS?
 if ((!defined('SMF')) && (!defined('FF_CHARS'))) die('Access denied!');

//  start by loading challange
function forumfirewall_Challenge() {
	//  Check if this is not comming from subs
	if (!function_exists('forumfirewall_clear_cookie')) return null; //  Hack attempt?

	//  Check to see if this is official
	if ((int) constant('FF_CHARS') !== 100) return null;

	global $txt, $language, $sourcedir, $context, $modSettings;

	$result = Array();

	//  Check if mod is on
	if (!isset($modSettings['forumfirewall_enable']) || !$modSettings['forumfirewall_enable']) return null;

	if (function_exists('loadlanguage')) {
		if (loadlanguage('ff_firewall', $language) === false)
			loadLanguage('ff_firewall', $language);
	} else {
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
		loadLanguage('ff_firewall', $language); }

	//  Prepare cookies
	$ff_cvalue = true;
	$ff_cookie_time = strval(time());
	if (!isset($_COOKIE['ff_token'])) {
		$context['ff_cookie_time'] = '';
		forumfirewall_set_cookie($ff_cvalue, $ff_cookie_time , 5);
		$context['ff_cookie_time'] = $ff_cookie_time;
	}

	//  A nasty surprise for wrong click(s)
	$context['honeyLink'] = $context['ff_Sho'] = '';
	$context['ff_Sho'] = array();
	$ff_cvalue = true;
	$context['ff_Sho'] = forumfirewall_get_random($ff_cvalue);
	$ff_cvalue = null;

	if (empty($modSettings['badbehavior_httpbl_link']))	{
		if (!empty($modSettings['httpBL_honeyPot_link']))
			$context['honeyLink'] = $modSettings['httpBL_honeyPot_link'];
	} else
			$context['honeyLink'] = $modSettings['badbehavior_httpbl_link'];

	//  Correct HTTP version?
	$context['forumfirewall_ protocol'] = '';
	$context['forumfirewall_ protocol'] = ((isset($_SERVER['SERVER_PROTOCOL']))  && (!empty($_SERVER['SERVER_PROTOCOL']))) ? $_SERVER['SERVER_PROTOCOL'] : @getenv('SERVER_PROTOCOL');
	if ($context['forumfirewall_ protocol'] != 'HTTP/1.0' && $context['forumfirewall_ protocol'] != 'HTTP/1.1') $context['forumfirewall_ protocol'] = 'HTTP/1.0';

	$forumfirewall_ip = '';
	$forumfirewall_ip = forumfirewall_get_real_ip_address();
	$forumfirewall_ip = forumfirewall_xss_safe($forumfirewall_ip);

	$forumfirewall_data = array(
		'visitor_ip' => $forumfirewall_ip,
	);

	$result = forumfirewall_get_cache_content($forumfirewall_ip);

	//  Time to make my version of a OWSAP CSRF token
	$forumfirewall_query_token = $ff_max = '';
	$forumfirewall_base64_alphabet = array();
	$forumfirewall_base64_alphabet = array_merge(array('/', '.'), range('a','z'), range(0, 9), range('A','Z'));
	$ff_max = count($forumfirewall_base64_alphabet) - 1;
	$ff_cvalue = true;
	mt_srand(forumfirewall_make_seed($ff_cvalue));
	$ff_cvalue = null;
	for ($ffi = 0; $ffi < 22; $ffi++) {
		$forumfirewall_query_token .= $forumfirewall_base64_alphabet[mt_rand(0, $ff_max)];
	}
	unset($forumfirewall_base64_alphabet);
	if (defined('CRYPT_SHA512') && CRYPT_SHA512) {
		$forumfirewall_query_token =  substr($forumfirewall_query_token, 0, 16);
		$forumfirewall_query_token = substr(crypt(md5(sha1(
			uniqid($forumfirewall_query_token, TRUE))),
			'$6$rounds=5001$'.$forumfirewall_query_token.'$'), 32);
	} elseif (defined('CRYPT_SHA256') && CRYPT_SHA256) {
		$forumfirewall_query_token =  substr($forumfirewall_query_token, 0, 16);
		$forumfirewall_query_token = substr(crypt(md5(sha1(
			uniqid($forumfirewall_query_token, TRUE))),
			'$5$rounds=5001$'.$forumfirewall_query_token.'$'), 32);
	} elseif (defined('CRYPT_BLOWFISH') && CRYPT_BLOWFISH) {
		$forumfirewall_blowf_salt = '';
		$forumfirewall_blowf_salt = '$2a$08$';
		if (@version_compare(PHP_VERSION, '5.3.7') != -1) {
			if (date('Ymd')  % 2)
			$forumfirewall_blowf_salt = '$2y$08$';
			else
				$forumfirewall_blowf_salt = '$2x$08$';
		}
		$forumfirewall_query_token = substr(crypt(md5(sha1(
			uniqid($forumfirewall_query_token, TRUE))),
			$forumfirewall_blowf_salt.'08$'.$forumfirewall_query_token.'$'), 29);
	} elseif ((function_exists('hash')) && (function_exists('hash_hmac'))) {
		$forumfirewall_query_token = ff_pbkdf2(md5(sha1(
			uniqid($forumfirewall_query_token, TRUE))), $forumfirewall_query_token);
	} else {	
		$forumfirewall_query_token = sha1(md5(sha1(
			uniqid($forumfirewall_query_token, TRUE))));
	}
	if (!isset($result[7]))	{
		$context['forumfirewall_query_token'] = '';
		$result[7] = $context['forumfirewall_query_token'] = $forumfirewall_query_token;
	}

	if (!isset($result[8])) $result[8] = $ff_cookie_time;  //  add -60 for test


	//  Make fail after the second time and henceforth
	$result[0] = '4';
	$result[1] = (is_array($result) && array_key_exists('1', $result) ? (empty($result[1]) ? '1' : (int) $result[1] + 1) : '1');
	$result[2] = null;
	$result[3] = '0';

	forumfirewall_savecache($forumfirewall_data, $result, 2);  //  Save tokins 
	$forumfirewall_query_token = $ff_max = $ff_cookie_time = null;

	//  Make the form images
	$context['ForumFirewall_Enter'] = ((forumfirewall_load_image($txt['forumfirewall_access']))?forumfirewall_load_image($txt['forumfirewall_access']):'');
	$context['ForumFirewall_Cancel'] = ((forumfirewall_load_image($txt['forumfirewall_noaccess']))?forumfirewall_load_image($txt['forumfirewall_noaccess']):'');

	//  Form submit text
	$context['ff_post'] = "?action=ffchallenge;submit;";

	// Load the form
	loadTemplate('ForumFirewall_Challenge');
	$context['sub_template'] = 'forumfirewall_challenge_form';
}

//  Lets put the form content through the ringer
function ff_Cverify() {
	global $modSettings;

	checkSession(); // Verify that the form has a "sc" element in it.

	//  Array to hold form post content
	$_crudy = $result = Array();

	//  Is this a post ('check for post' && 'confirm that smf - 3 letters (for smf) is in both referer and script') 
	if ((strtoupper($_SERVER['REQUEST_METHOD']) == "POST") && (similar_text(basename($_SERVER['HTTP_REFERER']),$_SERVER['SCRIPT_NAME']) >= 3)) {

		//  Sanitize post content
		if ((is_array($_POST) && array_key_exists('nojs', $_POST)) && (array_key_exists('submit_x', $_POST) && ctype_xdigit($_POST['submit_x'])) && ($_POST['submit_x'] === "1"))
			$_crudy['nojs'] = filter_input(INPUT_POST, 'nojs', FILTER_SANITIZE_NUMBER_INT);
		if ((is_array($_POST) && array_key_exists('submit_x', $_POST)) && (ctype_xdigit($_POST['submit_x']))) {
			$_crudy['submit_x'] = filter_input(INPUT_POST, 'submit_x', FILTER_SANITIZE_NUMBER_INT);
			$_crudy['submit_y'] = filter_input(INPUT_POST, 'submit_y', FILTER_SANITIZE_NUMBER_INT);
		}
		if ((is_array($_POST) && array_key_exists('submit1_x', $_POST)) && (ctype_xdigit($_POST['submit1_x']))) {
			$_crudy['submit1_x'] = filter_input(INPUT_POST, 'submit1_x', FILTER_SANITIZE_NUMBER_INT);
			$_crudy['submit1_y'] = filter_input(INPUT_POST, 'submit1_y', FILTER_SANITIZE_NUMBER_INT);
		}
		if(is_array($_POST) && array_key_exists('caputa', $_POST))
			$_crudy['caputa'] = filter_input(INPUT_POST, 'caputa', FILTER_SANITIZE_SPECIAL_CHARS);
		if(is_array($_POST) && array_key_exists('ctoken', $_POST))
			$_crudy['ctoken'] = filter_input(INPUT_POST, 'ctoken', FILTER_SANITIZE_SPECIAL_CHARS);
		if(is_array($_POST) && array_key_exists('message', $_POST))
			$_crudy['message'] = filter_input(INPUT_POST, 'message', FILTER_SANITIZE_STRING);

		//  Sanitize cookie
		if(isset($_COOKIE['ff_token'])) {
			$_crudy['ff_token'] = filter_input(INPUT_COOKIE, 'ff_token', FILTER_SANITIZE_NUMBER_INT);
			$_crudy['ff_token'] = forumfirewall_decode_content(true, $_crudy['ff_token']);
		}

		//  Get cached data
		$ff_query_token = $forumfirewall_ip_master = '';

		$forumfirewall_ip_master = forumfirewall_get_real_ip_address();
		$forumfirewall_ip_master = forumfirewall_xss_safe($forumfirewall_ip_master);

		//  check cache
		$cache_flag = false;
		$cache_test = false;
		if (isset($modSettings['forumfirewall_cache_duration']) && !empty($modSettings['forumfirewall_cache_duration']) && ((int) $modSettings['forumfirewall_cache_duration']) !== 0) $cache_test = true;

		//  Brute force - cache file is not there if ip changed
		if ($cache_test !== false) {
			$cache_flag = forumfirewall_checkCache($forumfirewall_ip_master);
			if ($cache_flag !== false)
				$result = forumfirewall_get_cache_content($forumfirewall_ip_master);
			else {
				$forumfirewall_ip_master = null;
				forumfirewall_prep_return('5424702632');
				return;
		}	}

		if (isset($result[7]))
			$ff_query_token = $result[7];

		$ff_query_token_time = '';
		if (isset($result[8]))
			$ff_query_token_time = filter_var($result[8], FILTER_SANITIZE_NUMBER_INT);

		$ff_user_agent_master = '';
		if (isset($result[6]))
			$ff_user_agent_master = $result[6];

		unset($result);

		//  Cancel pressed
		if (is_array($_crudy) && (array_key_exists('submit_x', $_crudy)) && (array_key_exists('submit_y', $_crudy))) {
			forumfirewall_prep_return('1354102620');
			return;
		}
		//  Enter pressed & test the kitchen sink
		if (is_array($_crudy) && (array_key_exists('submit1_x', $_crudy)) && (array_key_exists('submit1_y', $_crudy)))  {
			if (empty($ff_query_token) || empty($ff_query_token_time) || empty($ff_user_agent_master)) {
				forumfirewall_prep_return('1354102621');
				return;
			} elseif (!isset($_crudy['caputa'], $ff_query_token, $ff_query_token_time, $_crudy['ff_token'], $_crudy['ctoken'], $ff_user_agent_master)) {
				forumfirewall_prep_return('1354202622');
				return;
			} elseif ((int) $_crudy['ff_token'] !== (int) substr($ff_query_token_time ,-2)
) {
				forumfirewall_prep_return('1354202623');
				return;
			} elseif (((time() - (int) $ff_query_token_time) >= 300) || ((time() - (int) $ff_query_token_time) < 1) || ((time() - (int) $_crudy['caputa']) >= 300) || ((time() - (int) $_crudy['caputa']) < 1)) {
				forumfirewall_prep_return('1354302624');
				return;
			} elseif ($_crudy['ctoken'] !== $ff_query_token) {
				forumfirewall_prep_return('2714302625');
				return;
			} elseif (strlen(trim($_crudy['message'])) <= 0 || strlen(trim($_crudy['message'])) > 100) {
				forumfirewall_prep_return('8794902637');
				return;
			} elseif (isset($_crudy['nojs']) && ($_crudy['nojs'])) {
				forumfirewall_prep_return('8794902636');
				return;
			} elseif (strcmp(forumfirewall_validate_message($_crudy['message']), sha1(date('Ymd'))) !== 0) {
				forumfirewall_prep_return('2714502628');
				return;
			} else {
				//  Check to see if there is a session hack attempt
				$ff_user_agent = $ff_user_ip = '';
				$ff_user_ip = forumfirewall_get_real_ip_address();
				$ff_user_ip = forumfirewall_xss_safe($ff_user_ip);

				$ff_user_agent = forumfirewall_get_env('HTTP_USER_AGENT');
				$ff_user_agent = md5($ff_user_agent); // new 2.0.0

					if (strcmp($ff_user_agent_master, $ff_user_agent) !== 0) {
						$ff_user_agent_master =  $ff_user_agent = null;
						forumfirewall_prep_return('2714502628');
						return;
					}

					//  Brute force - cache file is not there if ip changed
					if ($cache_test !== false) {
						$cache_flag = forumfirewall_checkCache($ff_user_ip);
						if ($cache_flag === false) {
							$forumfirewall_ip_master = $ff_user_ip = null;
							forumfirewall_prep_return('5424702632');  // Brute force - ip changed
							return;
					}	}

					// Check for brute force
					$ff_user_ip = forumfirewall_ip2Bin($forumfirewall_ip_master);
					$forumfirewall_ip_master = forumfirewall_ip2Bin($forumfirewall_ip_master);

					if (strcmp($forumfirewall_ip_master, $ff_user_ip) !== 0) {
						$forumfirewall_ip_master = $ff_user_ip = null; // new 2.0.0
						forumfirewall_prep_return('5424702632');
						return;
					}
					$forumfirewall_ip_master = $ff_user_ip = null; // new 2.0.0

					//  	passed all tests
					forumfirewall_prep_return(date('Ymd'));
					return;
}	}	}	}


//  Test the heck out of message content
function forumfirewall_validate_message($message) {
	if(!is_string($message)) return null;  //  Bot scan
	// Sanitize Null Characters
	$message = preg_replace('/\0+/', '', $message);
	$message = preg_replace('/(\\\\0)+/', '', $message);
	// Sanitize standard character entities
	$message = preg_replace('#(&\#?[0-9a-z]{2,})([\x00-\x20])*;?#i', "\\1;\\2", $message);
	// Sanitize UTF16 two byte encoding (x00)
	$message = preg_replace('#(&\#x?)([0-9A-F]+);?#i',"\\1\\2;",$message);
	// Inspect & Convert UTF8
	if (forumfirewall_is_utf8($message)) $message = forumfirewall_my_utf8_decode($message);
	// Block URL Enccoding
	if (preg_match("/%u0([a-z0-9]{3})/i", $message)) return null;
	if (preg_match("/%([a-z0-9]{2})/i", $message)) return null;
	// Convert character entities to ASCII for further testing
	if(preg_match_all("/<(.+?)>/si", $message, $matches)) {        
    	for ($i = 0; $i < count($matches['0']); $i++) {
        	$message = str_replace($matches['1'][$i],
            html_entity_decode($matches['1'][$i], ENT_COMPAT, $txt['forumfirewall_charset']), $message);
    }	}
	// Convert all tabs to spaces
	if(strripos($message, "\t") !== FALSE) $message = str_replace("\t", ' ', $message);
	// Block Strings that are never allowed
	$exploits_array = array('document.cookie','document.write','.parentNode','.innerHTML','window.location','-moz-binding','<!--','-->','<![CDATA[', '<comment>','javascript\s*:','expression\s*(\(|&\#40;)','vbscript\s*:','Redirect\s+302','<?','?>','<?php');
		foreach ($exploits_array as $exploit) {
			$pos = strripos($message, $exploit);
			if ($pos !== false) {
				unset($exploit);
				return null;
		}	}
		unset($exploit);
	// Compact exploded words
	$words = array('javascript', 'expression', 'vbscript', 'script','applet', 'alert', 'document', 'write', 'cookie', 'window');

	foreach ($words as $word) {
    	$temp = '';
    	for ($i = 0; $i < strlen($word); $i++) {
    	    $temp .= substr($word, $i, 1)."\s*";
    	}

    	$temp = substr($temp, 0, -3);
    	$message = preg_replace('#'.$temp.'#s', $word, $message);
    	$message = preg_replace('#'.ucfirst($temp).'#s', ucfirst($word), $message);
	}
	unset($word);
	// Block disallowed Javascript in links or img tags
	if (preg_match("/<img/i", $message) OR preg_match("/<a/i", $message) OR preg_match("/script/i", $message) OR preg_match("/xss/i", $message)) return null;
	// All javascript event handlers (e.g. onload, onclick, onmouseover), style, and xmlns
		$exploits = array('on\w*', 'style', 'xmlns', 'formaction');
		do {
			$count = 0;
			$attribs = array();
			
			// find occurrences of illegal attribute without quotes
			if(preg_match("/(".implode('|', $exploits).")\s*=\s*([^\s]*)/is",  $message)) {
					return null;
			}
			// find occurrences of illegal attribute messageings with quotes (042 and 047 are octal quotes)
			if(preg_match("/(".implode('|', $exploits).")\s*=\s*(\042|\047)([^\\2]*?)(\\2)/is",  $message)) {
				return null;
			}

		} while ($count);

	//  Block JavaScript Event Handlers
	if(preg_match('#(<[^>]+.*?)(onblur|onchange|onclick|onfocus|onload|onmouseover|onmouseup|onmousedown|onselect|onsubmit|onunload|onkeypress|onkeydown|onkeyup|onresize)[^>]*>#iU', $message)) {
		return null;
	}
	// Block naughty HTML elements
		if(preg_match('#<(/*\s*)(alert|applet|audio|basefont|base|behavior|bgsound|blink|body|embed|expression|form|frameset|frame|head|html|ilayer|iframe|input|isindex|layer|link|meta|object|plaintext|style|script|textarea|title|video|xml|xss)([^><]*)([><]*)#is', $message)) {
		return null;
	}
	//  Block naughty scripting elements
	if(preg_match('#(alert|cmd|passthru|eval|exec|expression|system|fopen|fsockopen|file|file_get_contents|readfile|unlink)(\s*)\((.*?)\)#si', $message)) {
		return null;
	}

	//  Test for SQL injection attempt
	$exploits_array1 = array('option=com_smf&amp;controller=|register.php|smf.php|.php?id=|ID_MEMBER|ID_GROUP|lngfile|is_activated|emailAddress|additionalGroups|memberName|passwordSalt|form_members|phorum|++++++++++++++++++|&stop=true','&ved=','num_replies=7777777','admin;area=topic_view','attachments','avatars','boarddir','cache','config.inc','imagesdir','scripts','Settings.php','sourcedir','Sources','themedir','Themes/','/css','chr(','chr=','chr%20','%20chr','wget%20','%20wget','wget(','cmd=','%20cmd','cmd%20','roc/self/environ','rush','union','echr(','%20echr','echr%20','echr=','esystem(','esystem%20','exec(','exec%28','cp%20','%20cp','cp(','mdir%20','%20mdir','mdir(','mcd%20','mrd%20','rm%20','%20mcd','%20mrd','%20rm','mcd(','mrd(','rm(','mcd=','mrd=','mv%20','rmdir%20','mv(','rmdir(','chmod(','chmod%20','%20chmod','chmod(','chmod=','chown%20','chgrp%20','chown(','chgrp(','CONCAT','locate%20','locus7','storm7','grep%20','http://www.google.com/imgres?imgurl=http://','locate(','grep(','diff%20','kill%20','kill(','killall','passwd%20','%20passwd','passwd(','telnet%20','vi(','vi%20','insert%20into','select','sshphp','nigga(','$sesc','%20nigga','nigga%20','fopen','fwrite','%20like','like%20','_REQUEST','_GET','$REQUEST','$GET','.system','HTTP_PHP','&aim','%20getenv','getenv%20','new_password','&icq','/etc/password','/etc/shadow','/etc/groups','/etc/gshadow','HTTP_USER_AGENT','HTTP_HOST','/bin/ps','wget%20','uname\x20-a','/usr/bin/id','/bin/echo','/bin/kill','/bin/','/sbin/','/usr/sbin','/chgrp','/chown','/usr/bin','g\+\+','bin/python','bin/tclsh','bin/nasm','perl%20','traceroute%20','ping%20','.pl','/usr/X11R6/bin/xterm','lsof%20','/bin/mail','.conf','motd%20','HTTP/1.','.inc.php','config.php','cgi-','.eml','file\://','file://','fileditor','window.open','Java','javascript\://','ijavascript://','mg src','img%20src','.jsp','ftp.exe','xp_enumdsn','xp_availablemedia','xp_filelist','shell','nc.exe','.htpasswd','servlet','/etc/passwd','webadmin','wwwacl','~root','~ftp','.jsp','admin_','.history','bash_history','.bash_history','~nobody','server-info','server-status','reboot%20','nstview','remview','remoteview','halt%20','pcom','powerdown%20','/home/ftp','/home/www','secure_site, ok','chunked','org.apache','/servlet/con','<script','/robot.txt','/robots.txt','/perl','mod_gzip_status','db_mysql.inc','.inc','select%20from','select from','drop%20','getenv','http_','_php','php_','phpget','phpinfo()','phpwriter','<?','?>','sql=','%2527','<br','cc:','bcc:','\0','\r','\n','"%20or%200=0%20--','or%200=0%20--','"%20or%200=0%20#','or%200=0%20#','"%20or%20"x"="x','"%20or%201=1--','or%201=1--','"%20or%20"a"="a','")%20or%20("a"="a','hi"%20or%20"a"="a','hi"%20or%201=1%20--','hi")%20or%20("a"="a','c99shell','r57shell','99.txt','.txt','C99.PHP','crystalshell','phpshell','dtool','fetch%20','curl%20','lynx%20','ls%20-','/var/tmp','cd%20','_SERVER','$SERVER','$POST','rundll32','PHP_SELF','<iframe','<a href','<javascript','alert(','<img','<embed','<object','[php','%5bphp','%20src','%2f','%3f','%3a','%40','%3d','%26','%3c','%3e','%22','%23','%7b','%7d','%7c','%5c','%5e','%7e','%5b','%5d','%60','%25','%27','\x3b','\x2f','\x3f','\x3a','\x40','\x3d','\x26','\x3c','\x3e','\x22','\x23','\x7b','\x7d','\x7c','\x5c','\x5e','\x7e','\x5b','\x5d','\x60','\x25','\x27');
	foreach ($exploits_array1 as $exploit1) {
		$pos = strripos($message, $exploit1);
		if ($pos !== false) {
			unset($exploits_array1, $exploit1);
			return null;
	}	}
	unset($exploits_array1, $exploit1);
	//  Test for xss injection attempt forumfirewall_xxs
	$exploits_array2 = array('alert(','<applet','<a href','base','<behavior','<bgsound','<blink','<body','<div','<embed','eval','exec','<expression','file(','file (','FileInputStream','flash','fopen','<form','<frame','fsockopen','fromCharCode','<head','<html','<iframe','<ilayer','<input','<img','src=','src
=','<javascript','javascript:','javascript\:','window\.','document\.','document.write','\.cookie','<layer','<link','<lowsrc','<meta','<object','onabort','onactivate','onafterprint','onafterupdate','onbeforeactivate','onbeforecopy','onbeforecut','onbeforedeactivate','onbeforeeditfocus','onbeforepaste','onbeforeprint','onbeforeunload','onbeforeupdate','onblur','onbounce','oncellchange','onchange','onclick','oncontextmenu','oncontrolselect','oncopy','oncut','ondataavailable','ondatasetchanged','ondatasetcomplete','ondblclick','ondeactivate','ondrag','ondrop','onerror','onfilterchange','onfinish','onfocus','onhelp','onkeydown','onkeypress','onkeyup','onlayoutcomplete','onload','onlosecapture','onmousedown','onmouseenter','onmouseleave','onmousemove','onmouseout','onmouseover','onmouseup','onmousewheel','onmove','onpaste','onpropertychange','onreadystatechange','onreset','onresize','onresizeend','onresizestart','onrowenter','onrowexit','onrowsdelete','onrowsinserted','onscroll','onselect','onselectionchange','onselectstart','onstart','onstop','onsubmit','onunload','passthru','<plaintext','<?','?>','phpinfo','Redirect','<script','<scr\0ipt','</script','<style','.system','system(','<textarea','<title','unlink','<vbscript','xml','xss');
	foreach ($exploits_array2 as $exploit2) {
		$pos = strripos($message, $exploit2);
		if ($pos !== false) {
			unset($exploits_array2, $exploit2);
			return null;
	}	}
	unset($exploits_array2, $exploit2);
	//  search for pouplar spam words
	$exploits_array3 = array('#1','-online','100% satisfied','4U','Accept credit cards','acne','Act Now!','Additional Income','adipex','adult','advertisement','advertising','advicer','Affordable','All natural','All new','allergies','Amazing','amazing new discovery','ambien','Apply online','as seen on tv','ass','asthma','auto loan','auto loans','baccarrat','bachelor','Bargain','be your own boss','beat messageess','Best price','Billing address','bllogspot','booker','botox','burn fat','Buy direct','buy now','buy online','Call','call anywhere','Call free','came up a winner','Can\'t live without','Cards Accepted','career opportunity','career singles','Investment decision','carisoprodol','casino','casinos','Cents on the dollar','chatroom','cialis','Claims','Click / Click Here / Click Below','click here','click to play','Click to remove','click to win','Compare rates','Congratulations','Cost / No cost','credit card','cwas','cyclen','cyclobenzaprine','dating','day-trading','Dear friend','debt free','degree program','depression','discreet meeting','discreet meetings','discreet ordering','Do it today','doctor approved','doctor prescribed','earn a college degree','earn a degree','earn big','earn extra money','earning potential','easy money','eliminate your debt','escorts','Extra income','fast delivery','find someone special','find your match','fioricet','fire your boss','For free','forex','fountain of youth','Free and FREE','free cell phone','free degree','free diploma','free game','free games','free gas','free gift','Free installation','Free leads','free list','free listing','Free membership','free minutes','free money','free of debt','free offer','free phone','Free preview','free reading','free readings','free screen savers','free screensavers','Free website','freenet-shopping','fuck','Full refund','Get it now','get out of debt','get results','get results now','get rich quick','get your reading','Giving away','great discounts','Guarantee','health products','heartburn','Hidden','higher income','home owner','home workers','homeworkers','hot deals','housewife','housewives','href','incest','Increase sales','Increase traffic','Information you requested','Insurance','investment','Investment / no investment ','investor','ionamin','job search','join now','just released','Legal','levitra','loose weight','Lose','low interest','low interest rate','low interest rates','low prices','macinmessageuct','mail list','mailing list','make a living','make money','make money at home','Marketing','Marketing solutions','matchmaker','matchmaking','medications','meds','meet new singles','meet singles','meet someone special','meridia','Message contains','million dollars','millions of dollars','Money','Month trial offer','more income','morgage','mortgage','muscle relaxants','Name brand','new product','No gimmicks','No Hidden Costs','No-obligation','oem','Offer','One time / one-time','online gambling','online-gambling','Opportunity','Order / Order Now / Order today / Order status','Orders shipped by priority mail','pain relief','paxil','Performance','pharmacy','phendimetrazine','phentamine','phentermine','pheramones','pherimones','photos of singles','platinum-celebs','Please read','poker-chip','Potential earnings','poze','Pre-approved','prescription','Price','Print out and fax','privacy assured','product for less','products for less','Profits','protect yourself','psychic','quit smoking','quit your job','Real thing','recover your losses','Removal instructions','Remove','Risk free','sale','Sales','Satisfaction guaranteed','save','Save $','Save up to','scratch and win','scratch off','scratch-off','Search engines','searching for you','See for yourself','Seek','sell now','Serious cash','sex','sexual health','shit','sign up','sign up now','signup','sleeping disorders','slot-machine','Solution','soma','Special promotion','stock quotes','stop paying','substantial income','Success','super deal','super deals','taboo','take a survey','take surveys','tarot','teen','teenage','teens','tenuate','The following form','tramadol','trim-spa','triple-x','tripple x','tripplex','ultram','university diploma','Unsolicited','Unsubscribe','Urgent','US dollars','venture capitol','viagara','viagra','vioxx','web cam','weight reduction','Win','win now','Winner','winner confirmation','winning number','Work at home','work at home','worry free','worry-free','x rated','x x x','x-rated','xanax','xenical','xxx','you have won','you won','You\'re a winner','zero percent','zolus');
	foreach ($exploits_array3 as $exploit3) {
		$pos = strripos($message, $exploit3);
		if ($pos !== false) {
			unset($exploits_array3, $exploit3);
			return null;
	}	}
	unset($exploits_array3, $exploit3);
	//  Passed all tests
	return sha1(date('Ymd'));
}

function forumfirewall_prep_return($forumfirewall_form_result) {
	if (empty($forumfirewall_form_result)) return null; //  bot scan

	global $modSettings, $sourcedir;

	if (!function_exists('forumfirewall_savecache')) return null; //  Hack attempt?

	if (!isset($forumfirewall_form_result) || empty($forumfirewall_form_result)) return null; //  scan

	$forumfirewall_data = $result = Array();

	//  Clean up
	if (isset($_COOKIE['ff_token'])) forumfirewall_clear_cookie(true);

	//  prepare call back test
	$result[4] = strval($forumfirewall_form_result);
	$result[5] = strval(time());

	//  do cache
	if ((isset($modSettings['forumfirewall_cache_duration'])) && (!empty($modSettings['forumfirewall_cache_duration'])) && (((int) $modSettings['forumfirewall_cache_duration']) !== 0)) {

		//  Get ready to load data
		$forumfirewall_ip = '';
		$forumfirewall_ip = forumfirewall_get_real_ip_address();
		$forumfirewall_ip = forumfirewall_xss_safe($forumfirewall_ip);

		//  Make data array
		$forumfirewall_data = forumfirewall_load_data($forumfirewall_ip);

		$result[0] = '4';
		$result[1] = '1';
		$result[2] =  ($forumfirewall_form_result == date('Ymd') ? time() + 86400 : null);
		$result[3] = ($forumfirewall_form_result == date('Ymd') ? '13'. date('Ymd') : $forumfirewall_form_result);

		forumfirewall_savecache($forumfirewall_data, $result, 3);
	}

	if (!function_exists('redirectexit'))
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs.php');
	redirectexit('',false);

	return;
}
function forumfirewall_decode_content($ff_cvalue, $ff_cookie_data) {
	if (empty($ff_cvalue)) return null;
	if (empty($ff_cookie_data)) return null;

	$tmpStr = '';
	$ff_intLevel = substr($ff_cookie_data, 1, substr($ff_cookie_data, 0, 1));
	$ff_startStr = substr($ff_cookie_data, substr($ff_cookie_data, 0, 1)+1, strlen($ff_cookie_data));
	for ($j = 0; $j < $ff_intLevel; $j++) {
		for ($i = 0;$i<strlen($ff_startStr);$i+=2)
			$tmpStr .= chr(intval(substr($ff_startStr, $i, 2)));
		$ff_startStr = $tmpStr;
		$tmpStr = '';
	}
	return $ff_startStr;
}
?>