<?php
/**********************************************************************************
* Subs_ForumFirewall.php - PHP class SMF 2.x template for ForumFirewall mod
* Version 2.0.1 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

if (!defined('SMF')) die('Hacking attempt...');

//  Look up IP address
function forumfirewall_get_real_ip_address($ff_return_arry = false) {
	global $modSettings;

	$i = 0;
	$ff_keys = $header_ips = $header_start = $header_end = $forumfirewall_ip_arrays = array();
	$ff_key = '';

	if ($ff_return_arry && $modSettings['forumfirewall_enable_proxy']) {
		global  $txt;
		$ff_proxy_error = false;
	}

	//  Headers sorted by trust left to right (if no proxy Remote-Addr moves to front)
	if (isset($modSettings['forumfirewall_real_ip']) && !empty($modSettings['forumfirewall_real_ip']) && $modSettings['forumfirewall_enable_proxy'])
			$header_start = array(ff_StrFmt_callback($modSettings['forumfirewall_real_ip']), 'Remote-Addr');
	elseif ((!isset($modSettings['forumfirewall_real_ip']) || empty($modSettings['forumfirewall_real_ip'])) && $modSettings['forumfirewall_enable_proxy'])
			$header_end = array('Remote-Addr');
	else
			$header_start = array('Remote-Addr');
	$header_keys = array('Http-Client-Ip', 'Http-X-Forwarded-For', 'Http-X-Forwarded', 'Http-X-Cluster-Client-Ip', 'Http-Forwarded-For', 'Http-Forwarded', 'Http-Via', 'Http-X-Coming-From', 'Http-Coming-From', 'Http-X-Real-Ip', 'Http-Z-Forwarded-For', 'Http-Iv-Remote-Address-Ipv6', 'Http-Iv-Remote-Address');

	$header_keys = array_unique(array_filter(array_merge($header_start, $header_keys, $header_end)), SORT_STRING);

	foreach ($_SERVER as $h => $v) {
		$ff_key = ff_StrFmt_callback($h);
		if (in_array($ff_key, $header_keys) !== false) {
			if ((int) $i > 0) {
				//  Case insensitive array_key_exists
				if (array_key_exists($ff_key , array_flip(array_map('ff_StrFmt_callback', $ff_keys)))) {
					//  Header key mismatch
					if ($ff_return_arry && $modSettings['forumfirewall_enable_proxy'] && !array_key_exists($h , $ff_keys))
						$ff_proxy_error = ' ' . $ff_key . ' ' . $txt['8564502628'] . $txt['forumfirewall_reason1'];  // header key mismatch
					//  Check for duplicates
					if ($ff_return_arry && $modSettings['forumfirewall_enable_proxy']) {
						$forumfirewall_ip_arrays = ff_IPArray($header_ips[$ff_key]);
						foreach (ff_IPArray($v) as $forumfirewall_ip)
							if (in_array($forumfirewall_ip, $forumfirewall_ip_arrays) !== false) {
								// duplicate IPs
								$ff_proxy_error  = ' ' . $forumfirewall_ip . ' x2' . $txt['forumfirewall_reason1'];
								break;
							}
						unset($forumfirewall_ip);
						}
					$header_ips[$ff_key] = ff_concatIParray($header_ips[$ff_key], $v);
				} else
					if (strpos($v, ',') !== false)
						$header_ips[$ff_key] = forumfirewall_clean_header($v);
					else
						$header_ips[$ff_key] = forumfirewall_StripMask($v);
			} else
					if (strpos($v, ',') !== false)
						$header_ips[$ff_key] = forumfirewall_clean_header($v);
					else
						$header_ips[$ff_key] = forumfirewall_StripMask($v);
			$ff_keys[(int) $i] = $h;
			$i++;
	}	}
	unset($h, $v);

	// Forwarded ip(s) do not include the client ip(s).
	if ($ff_return_arry && $modSettings['forumfirewall_enable_proxy'] && array_key_exists('Http-Client-Ip', $header_ips) && array_key_exists('Http-X-Forwarded-For', $header_ips)) {
		$client_ip = $forwarded_ip = '';
		$client_pos = $forwarded_pos = $pos = false;
		if (strpos($header_ips['Http-Client-Ip'], ',') !== false) {
			$client_ips = array();
			$client_pos = true;
			$client_ips = ff_IPArray($header_ips['Http-Client-Ip']);
		} else
			$client_ip = $header_ips['Http-Client-Ip'];

		if (strpos($header_ips['Http-X-Forwarded-For'], ',') !== false) {
			$forwarded_ips = array();
			$forwarded_pos = true;
			$forwarded_ips = ff_IPArray($header_ips['Http-X-Forwarded-For']);
		} else
			$forwarded_ip = $header_ips['Http-X-Forwarded-For'];

		if ($client_pos && $forwarded_pos) {
    		foreach ($client_ips as $client_ip)
				if (in_array($client_ip, $forwarded_ips)) {
					$pos = true;
					break;
				}
			unset($client_ip);
		} elseif ($client_pos) {
				if (in_array($forwarded_ip, $client_ips))
					$pos = true;
		} elseif ($forwarded_pos) {
				if (in_array($client_ip, $forwarded_ips))
					$pos = true;
		 } elseif ($forwarded_ip == $client_ip)
				$pos = true;

		if ($pos === false)
			$ff_proxy_error = ' "Client-Ip" != "X-Forwarded-For"'. $txt['forumfirewall_reason1'];
			// "Client-Ip" != "X-Forwarded-For"
	}

	//  Sort found headers by trust left to right
    $forumfirewall_ip_arrayz = array();
    foreach (array_flip($header_keys) as $h => $v)
        if (array_key_exists($h, $header_ips)) {
                $forumfirewall_ip_arrayz[$h] = $header_ips[$h];
                unset($header_ips[$h]);
        }
	unset($h, $v);

	$header_ips = $forumfirewall_ip_arrayz + $header_ips;

	$forumfirewall_ips = $forumfirewall_ip_array = array();
	$forumfirewall_ip = '';

	if (empty($header_ips)) {
		$forumfirewall_ip = empty($_SERVER['REMOTE_ADDR']) ? '0.0.0.0': $_SERVER['REMOTE_ADDR'];
		return ($ff_return_arry && $modSettings['forumfirewall_enable_proxy']) ? array($forumfirewall_ip, $ff_proxy_error) : $forumfirewall_ip;
	}

	// Finish headers
	foreach ($header_ips as $header_ip) {
		$pos = false;
		if (strpos($header_ip, ',') !== false) {
			$pos = true;
			//  Remove blanks just incase arrays are 0,0
			$forumfirewall_ip_array = array_filter(ff_IPArray($header_ip));
			// Reverse array order
			$forumfirewall_ip_array = array_reverse($forumfirewall_ip_array);
		} else
			$forumfirewall_ip = $header_ip;

		if (empty($forumfirewall_ips) && !empty($forumfirewall_ip))
			$forumfirewall_ips = array_merge((array) $forumfirewall_ip);
		else
			$forumfirewall_ips = array_merge($forumfirewall_ips, ($pos ? $forumfirewall_ip_array : (array) $forumfirewall_ip));
	}
	unset($header_ips, $header_ip);  // header_ips deleted as a precaution

	$forumfirewall_ips = forumfirewall_array_flatten($forumfirewall_ips);

	//  Remove trusted proxies
	$forumfirewall_ips = array_filter($forumfirewall_ips, 'ff_trustedIP_callback');

	if (empty($forumfirewall_ips)) {
		$forumfirewall_ip = empty($_SERVER['REMOTE_ADDR']) ? '0.0.0.0': $_SERVER['REMOTE_ADDR'];
		return ($ff_return_arry && $modSettings['forumfirewall_enable_proxy']) ? array($forumfirewall_ip, $ff_proxy_error) : $forumfirewall_ip;
	}

	//  Validate all Ip address
	foreach ($forumfirewall_ips as $forumfirewall_ipt) {
		$pos = (((forumfirewall_IPv4orIPv6($forumfirewall_ipt) !== false) ? forumfirewall_check_ip6($forumfirewall_ipt) : forumfirewall_check_ip4($forumfirewall_ipt)));
		if ($pos !== false)
			unset($forumfirewall_ipt);
		else {
			$forumfirewall_ip = $forumfirewall_ipt;
			break;  //  We found a good IP
		}
	}
	unset($forumfirewall_ipt);

	if (empty($forumfirewall_ip)) {
		$forumfirewall_ip = empty($_SERVER['REMOTE_ADDR']) ? '0.0.0.0': $_SERVER['REMOTE_ADDR'];
		if ($modSettings['forumfirewall_enable_proxy']) $ff_proxy_error = true;  //  All IPs failed
	}

	return ($ff_return_arry && $modSettings['forumfirewall_enable_proxy']) ? array($forumfirewall_ip, $ff_proxy_error) : $forumfirewall_ip;
}
//  Standardize and IP array
function ff_StrFmt_callback($ff_string) {
	return str_replace(' ', '-', ucwords(strtolower(str_replace(array('_', '-'), ' ', $ff_string))));
}
// Concatenate Multiple message-header field per RFC2616
function ff_concatIParray($forumfirewall_old_list, $forumfirewall_new_list) {
	$forumfirewall_old_array = $forumfirewall_new_array = $forumfirewall_ip_array = array();

	$forumfirewall_old_array = ff_IPArray($forumfirewall_old_list);
	$forumfirewall_new_array = ff_IPArray($forumfirewall_new_list);

	//  Delete empty and bad IPs from array
	$forumfirewall_new_array = array_filter($forumfirewall_new_array, 'ff_delIP_callback');

	// Detect and remove masks
	$forumfirewall_new_array = array_map('ff_cleanIP_callback', $forumfirewall_new_array);

	//  Make sure new array is not empty
	if (count($forumfirewall_new_array) !== 0)  //  merge and remove duplicates
		$forumfirewall_ip_array = array_unique(array_merge($forumfirewall_old_array, $forumfirewall_new_array), SORT_STRING);
	else
		$forumfirewall_ip_array = $forumfirewall_old_array;

	return implode(',', $forumfirewall_ip_array);
}
//  Convert a comma delimited (with or without spaces) IP string to array
function ff_IPArray($header_keys) {

	$forumfirewall_ip_array = array();
	if (strpos($header_keys, ',') !== false)
		$forumfirewall_ip_array = array_map('trim', explode(',', $header_keys));
	else
		$forumfirewall_ip_array[0] = trim($header_keys);

	return $forumfirewall_ip_array;
}
//  A callable function to delete trusted IPs
function ff_trustedIP_callback($forumfirewall_ip) {

	//  Future enable the ability to add user trusted proxies
	$trusted_proxie_regs = array(
		'/^127.(?!0.0.1)/', //					localhost IPv4 127/8 except 127.0.0.1 Simple Machines if 1st IP
		'/^169.254./',  //						private IPv4 range 69.254/16
		'/^::1/',  //							localhost IPv6
		'/^0:0:0:0:0:0:0:1/', //				localhost IPv6
		'/^[fF][cCdD]/',  //					private IPv6 range fc00::/7
		'/^10./',  //							private IPv4 10/8
		'/^172.(1[6-9]|2[0-9]|3[0-1])\./',  //	private IPv4 range 172.16/12
		'/^192.168./'  //						private IPv4 range 192.168/16
    );

	foreach ($trusted_proxie_regs as $trusted_proxie_reg)
		if(preg_match($trusted_proxie_reg, $forumfirewall_ip)) {
			unset($trusted_proxie_reg);
			return false;
			break;
		}
	unset($trusted_proxie_reg);

	if (empty($forumfirewall_ip)) return false;

	return  true;
}
//  A callable function used to clean IPs
function ff_delIP_callback($forumfirewall_ip) {

	if (empty($forumfirewall_ip)) return false;
	$octet = '';

	// Quickie strip IPs of common errors and trusted localhost + unix
	$needle_arrys = array('"', '\'', '=', 'http/', 'alive', 'localhost', 'unix');
	foreach ($needle_arrys as $needle)
		if (strpos(strtolower($forumfirewall_ip), $needle) !== false) {
			unset($needle);
			return false;
			break;
		}
	unset($needle);

	if (strpos($forumfirewall_ip, ':') !== false) { //  check ipv6 or ipv4 w mask
		$octet = explode(':', $forumfirewall_ip);
		if (count($octet) > 2)  // IPv6
			return true;
		elseif (count($octet) == 2 && strpos($forumfirewall_ip, '.') !== false) {  //  IPv4?
				$octet = explode('.', $forumfirewall_ip);
				if (count($octet) !== 4)
					return false;
				else
					return true;
		}
	} elseif (strpos($forumfirewall_ip, '.') !== false) {  //  IPv4 no mask
		$octet = explode('.', $forumfirewall_ip);
		if (count($octet) !== 4)
			return false; //  Not ipv4
		else
			return true;
	}

	return false;
}
// A callable function to fix IP masks - this function is to be run after ff_delIP_callback 
function ff_cleanIP_callback($forumfirewall_ip) {

	if (strpos($forumfirewall_ip, ':') !== false) { //  check ipv6 or ipv4 w mask
		$octet = explode(':', $forumfirewall_ip);
		if (count($octet) > 2)  // IPv6
			$forumfirewall_ip = forumfirewall_noMask($forumfirewall_ip);
		elseif (count($octet) == 2)		//  IPv4?
			if (strpos($forumfirewall_ip, '.') !== false)
				if (count($octet) !== 4) {
					$ff_ipPart = array();
					$ff_ipPart = explode(':', $forumfirewall_ip);
					$forumfirewall_ip = $ff_ipPart[0];
	}			}

	return $forumfirewall_ip; 
}
//  Clean up header CSV ips
function forumfirewall_clean_header($forumfirewall_ip) {

	if (empty($forumfirewall_ip)) return false;
	$forumfirewall_ip_array = array();

	$forumfirewall_ip_array = array_unique(ff_IPArray($forumfirewall_ip), SORT_STRING);
	$forumfirewall_ip_array = array_filter($forumfirewall_ip_array, 'ff_delIP_callback');
	$forumfirewall_ip_array = array_map('ff_cleanIP_callback', $forumfirewall_ip_array);
	$forumfirewall_ip = implode(',', $forumfirewall_ip_array);

	return $forumfirewall_ip;
}
//  Clean IPs - False = delete
function forumfirewall_StripMask($forumfirewall_ip) {

	if ($forumfirewall_ip == '') return false;
	$octet = '';

	// Quickie strip IPs and trusted localhost + unix
	$needle_arrys = array('"', '\'', '=', 'http/', 'alive', 'localhost', 'unix');
	foreach ($needle_arrys as $needle)
		if (strpos(strtolower($forumfirewall_ip), $needle) !== false) {
			$forumfirewall_ip = false;
			break;
		}
	unset($needle);
	
	if (strpos($forumfirewall_ip, ':') !== false) { //  check ipv6 or ipv4 w mask
		$octet = explode(':', $forumfirewall_ip);
		if(count($octet) > 2)  // IPv6
			$forumfirewall_ip = forumfirewall_noMask($forumfirewall_ip);
		else		//  IPv4
			if (strpos($forumfirewall_ip, ':') !== false) {
				$ff_ipPart = array();
				$ff_ipPart = explode(':', $forumfirewall_ip);
				$forumfirewall_ip = $ff_ipPart[0];
			}
	} elseif (strpos($forumfirewall_ip, '.') !== false) {  //  IPv4 no mask
		$octet = explode('.', $forumfirewall_ip);
		if (count($octet) !== 4)
			$forumfirewall_ip = false; //  Not ipv4
	} else
		$forumfirewall_ip = false; //  Not IP

	return $forumfirewall_ip; 
}
function forumfirewall_uc($string) {
	$temp = preg_split('/(\W)/', str_replace('_', '-', $string), -1, PREG_SPLIT_DELIM_CAPTURE);
	foreach ($temp as $key=>$word) {
		$temp[$key] = ucfirst(strtolower($word));
	}
	unset($key, $word);
	return implode('', $temp);
}
function forumfirewall_get_env($htvars) {
	if (isset($_SERVER[$htvars]) && !empty($_SERVER[$htvars]))
		return forumfirewall_clean_env($_SERVER[$htvars]);
	elseif (isset($_ENV[$htvars]) && !empty($_ENV[$htvars]))
		return forumfirewall_clean_env($_ENV[$htvars]);
	return false;
}
function forumfirewall_clean_env($htvars) {
	$htvars = trim($htvars);
	$htvars = strip_tags($htvars);
	$htpat = array('\r\n', '\n\r', '\n', '\r'); // remove returns
	$htvars = str_replace($htpat, '', $htvars);
	$htpata = array('/^\s+/', '/\s{2,}/', '/\s+\$/'); // remove multiple whitespaces
	$htrep = array('', ' ', '');
	$htvars = preg_replace($htpata, $htrep, $htvars);
	$htvars = trim($htvars);
//	unset($htpat, $htpata, $htrep);  //  Array too small to bother
	return $htvars;
}
function forumfirewall_get_real_uri() {
	$request_uri = '';
	if (forumfirewall_get_env('HTTP_X_REWRITE_URL'))
		$request_uri = forumfirewall_get_env('HTTP_X_REWRITE_URL');
	elseif ((forumfirewall_get_env('IIS_WasUrlRewritten')) && (forumfirewall_get_env('IIS_WasUrlRewritten') == '1')
				&& (forumfirewall_get_env('UNENCODED_URL')) && (forumfirewall_get_env('UNENCODED_URL') != ''))
		$request_uri = forumfirewall_get_env('UNENCODED_URL');
	elseif (forumfirewall_get_env('REQUEST_URI')) {
		$request_uri = forumfirewall_get_env('REQUEST_URI');
		if ((forumfirewall_get_env('HTTP_HOST')) && (strstr($request_uri , forumfirewall_get_env('HTTP_HOST')))) {
			$parts = @parse_url($request_uri);
			if ($parts !== false)
				$requestUri  = (empty($parts['path']) ? '' : $parts['path'])
								. ((empty($parts['query'])) ? '' : '?' . $parts['query']);
		}
	} elseif ((forumfirewall_get_env('ORIG_PATH_INFO')) || (forumfirewall_get_env('PATH_INFO'))) {
		$request_uri = (forumfirewall_get_env('ORIG_PATH_INFO') ? forumfirewall_get_env('ORIG_PATH_INFO') : forumfirewall_get_env('PATH_INFO'));
		if (forumfirewall_get_env('QUERY_STRING')) {
			if (strpos(forumfirewall_get_env('REQUEST_URI'), forumfirewall_get_env('QUERY_STRING')) === false) {
				$request_uri .= '?' . forumfirewall_get_env('QUERY_STRING');
		}	}
	} elseif (forumfirewall_get_env('QUERY_STRING')) {
		if (forumfirewall_get_env('SCRIPT_NAME'))
			$request_uri = forumfirewall_get_env('SCRIPT_NAME') . '?' . forumfirewall_get_env('QUERY_STRING'); 
		else { 
			$request_uri = forumfirewall_get_env('PHP_SELF') .'?'. forumfirewall_get_env('QUERY_STRING');
			$request_uri = '/' . ltrim($request_uri, '/');
		}
	} else
		$request_uri = forumfirewall_get_env('SCRIPT_NAME');

	return $request_uri;
}
function forumfirewall_load_data($forumfirewall_ip) {

	$request_entity = array();
	if (!strcasecmp(forumfirewall_get_env('REQUEST_METHOD'), 'POST') || !strcasecmp(forumfirewall_get_env('REQUEST_METHOD'), 'PUT')) {
		foreach ($_POST as $h => $v) {
			$request_entity[$h] = $v;
		}
		unset($h, $v);
		$request_entity = forumfirewall_limit($request_entity);	
	}

	$forumfirewall_data = array(
		'visitor_ip' => $forumfirewall_ip,
		'request_method' => trim(forumfirewall_get_env('REQUEST_METHOD')),
		'request_uri' => trim(forumfirewall_get_real_uri()),
		'referer' => trim(forumfirewall_get_env('HTTP_REFERER')),
		'user_agent' => trim(forumfirewall_get_env('HTTP_USER_AGENT')),
		'server_protocol' => trim(forumfirewall_get_env('SERVER_PROTOCOL')),
		'request_entity' => $request_entity,
		'sql_reason' => '999',
	);
//	unset($request_entity);  //   Array is now limited
	return $forumfirewall_data;
}
 //  flatten and limit array keys to save memory
function forumfirewall_limit($ff_val) {
	if (is_array($ff_val)) {
		$ff_val = forumfirewall_array_flatten($ff_val);
		if (count($ff_val) > 25)
			$ff_val = array_slice($ff_val, 0, 25);
	}
	return $ff_val;
}
// Returns XSS-safe equivalent of string
function forumfirewall_xss_safe($ff_data) {

	static $ff_quoting = null;
	if ($ff_quoting === null) {
		global $forum_version;
		if (strpos($forum_version, '2.1') !== false)  //  SMF 2.1.x uses HTML5
			$ff_quoting = ENT_QUOTES | (defined('ENT_HTML5') ? ENT_HTML5 : (defined('ENT_XML1') ? ENT_XML1 : (defined('ENT_XHTML') ? ENT_XHTML : (defined('ENT_HTML401') ? ENT_HTML401 : 0))));
		else //  SMF 1.0 through 2.0 use XHTML 1.0 Transitional
			$ff_quoting = ENT_QUOTES | (defined('ENT_XML1') ? ENT_XML1 : (defined('ENT_HTML5') ? ENT_HTML5 : (defined('ENT_XHTML') ? ENT_XHTML : (defined('ENT_HTML401') ? ENT_HTML401 : 0))));
	}

	if (is_array($ff_data))
		return array_map('forumfirewall_xss_safe', $ff_data);

	return htmlspecialchars($ff_data, $ff_quoting);
}
//  IPV6 SAFE but removed deep IP array vaildation.  Will assume checkdns will verify.
function forumfirewall_checkAdmin($forumfirewall_ip) {
	global $modSettings;
	$pos = true;

	if (forumfirewall_IPv4orIPv6($forumfirewall_ip) !== false) {
		//  IPv6
		$admin_ipBin_lo = forumfirewall_inet_pton($modSettings['forumfirewall_admin_ip_lo']);
		$admin_ipBin_hi = forumfirewall_inet_pton($modSettings['forumfirewall_admin_ip_hi']);
		$forumfirewall_ipBin = forumfirewall_inet_pton($forumfirewall_ip);

	} else {
		// IPv4
		$admin_ipBin_lo = ff_ip2long($modSettings['forumfirewall_admin_ip_lo']);
		$admin_ipBin_hi = ff_ip2long($modSettings['forumfirewall_admin_ip_hi']);
		$forumfirewall_ipBin = ff_ip2long($forumfirewall_ip);
	}

	if ((strlen($forumfirewall_ipBin) == strlen($admin_ipBin_lo)) &&  ($forumfirewall_ipBin >= $admin_ipBin_lo && $forumfirewall_ipBin <= $admin_ipBin_hi)) {
		// In range
		if (forumfirewall_checkdns($forumfirewall_ip, $modSettings['forumfirewall_admin_domain'])) $pos = false;
	}
	return $pos;
}
//  Searching SMF DB will not work since SMF is not IPv6 compatible so we assume it can be bad in ForumFirewall.php
function forumfirewall_checkGoodgroup($forumfirewall_ip) {
	global $sourcedir, $context, $user_info, $smcFunc;

	if ($forumfirewall_ip == '') return true;

	//  Look up ip address and check
	$forumfirewall_goodgroup = array();
	$dos_cond = true;

	$qresult = $smcFunc['db_query']('', '
		SELECT id_group, permission, add_deny
		FROM {db_prefix}permissions
		WHERE permission = {string:search_permission}
			AND add_deny = {int:permission_state}',
		array(
			'search_permission' => 'forumfirewall_goodgroup',
			'permission_state' => 1,
		)
	);

	if ($smcFunc['db_num_rows']($qresult) > 0) {
		while ($row = $smcFunc['db_fetch_assoc']($qresult)) {
			$forumfirewall_goodgroup[$row['permission']] = $row['id_group'];
	}	}
	$smcFunc['db_free_result']($qresult);

	if (!empty($forumfirewall_goodgroup)) {
		if (function_exists('loadIllegalPermissions'))
			loadIllegalPermissions();
		else {
			require_once($sourcedir . DIRECTORY_SEPARATOR . 'ManagePermissions.php');
			loadIllegalPermissions(); }
		foreach ($forumfirewall_goodgroup as $perm => $group_id) {
			if ($user_info['groups']['0'] == $group_id) {
				$dos_cond = false;
				break; }
			if (!empty($context['illegal_permissions']) && in_array($perm, $context['illegal_permissions'])) {
				$dos_cond = true;
				break; }
			$qresult = $smcFunc['db_query']('', '
				SELECT
					id_group, member_ip, member_ip2, is_activated
				FROM {db_prefix}members
				WHERE member_ip = {string:ipofuser}
					OR member_ip2 = {string:ipofuser}',
				array(
					'ipofuser' => $forumfirewall_ip,
				)
			);
			if ($smcFunc['db_num_rows']($qresult) > 0) {
				while ($row = $smcFunc['db_fetch_assoc']($qresult)) {
					if ($row['id_group'] == $group_id) {
						$dos_cond = false;
						if ($row['is_activated'] >= 10) $dos_cond = true;  //  is_banned
						break;
			}	}	}
	$smcFunc['db_free_result']($qresult); }
	unset($perm, $group_id); }

	unset($forumfirewall_goodgroup);  //  Arrray has unkown size

	return $dos_cond;
}
function forumfirewall_checkCache($forumfirewall_ip) {
	global $modSettings, $ffcachedir;
	if ($forumfirewall_ip == '') return false;
	$forumfirewall_ip = forumfirewall_ip2DB($forumfirewall_ip);

	$stamp = $ff_filename = $forumfirewall_algo = $key = '';  //  $cache_content
	$stamp = date('Ymd');

	if (function_exists('hash')) {
		$forumfirewall_algo = forumfirewall_get_hash($stamp);
		$key = hash($forumfirewall_algo,serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt'].$stamp));
	} else
		$key = sha1(serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt']));

	$ff_filename = $ffcachedir . DIRECTORY_SEPARATOR . 'ff_' . $key . '.php';
	$stamp = $key = null;

	if (is_file($ff_filename)) {
		@clearstatcache(true, $ff_filename);
		unset($ff_filename);
		return true; }

	unset($ff_filename);
	return false;
}
function forumfirewall_get_cache_content($forumfirewall_ip) {
	global $modSettings;
	$result = $cache_content = array();
	$stamp = '';  // $cache_content
	$stamp = date('Ymd');
	$forumfirewall_ip = forumfirewall_ip2DB($forumfirewall_ip);

	if (function_exists('hash')) {
		$forumfirewall_algo = forumfirewall_get_hash($stamp);
		$cache_content = forumfirewall_cache_get_data(hash($forumfirewall_algo,serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt'].$stamp)), 0);
	} else
		$cache_content = forumfirewall_cache_get_data(sha1(serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt'])), 0);

	$result = unserialize($cache_content); // $resulta - future try Serializable obj if (@version_compare(PHP_VERSION, '5.2.0') != -1)

	unset($cache_content);

	return $result;
}
function forumfirewall_savecache($forumfirewall_data, $result, $toggle = 0) {

	global $modSettings;
	if (empty($forumfirewall_data)) return;
	if (!is_array($forumfirewall_data)) return;

	if (empty($result)) return;
	if (!is_array($result)) return;

	$ttlbol = false;

	$forumfirewall_ip = $forumfirewall_data['visitor_ip'];

	$forumfirewall_cach_array = array();
	if (is_array($result) && (array_key_exists(0, $result)))
		$forumfirewall_cach_array[0] = $result[0];  //  ID
	if (is_array($result) && (array_key_exists(1, $result)))
		$forumfirewall_cach_array[1] = $result[1];  //  Count
	if (is_array($result) && (array_key_exists(2, $result)))
		$forumfirewall_cach_array[2] = $result[2];  //  First Timestamp
	$forumfirewall_cach_array[3] = (empty($result[3]) ? '0' : $result[3]);  //  Form Token

	switch ((int) $toggle) {
		case 0:
			break;
		case 1:
			if (is_array($result) && array_key_exists(6, $result))
				$forumfirewall_cach_array[6] = $result[6];
			else
				$forumfirewall_cach_array[6] = md5($forumfirewall_data['user_agent']);
			if (is_array($result) && array_key_exists(7, $result))  //  query token
				$forumfirewall_cach_array[7] = $result[7];
			if (is_array($result) && array_key_exists(8, $result))  //  token_time
				$forumfirewall_cach_array[8] = $result[8];
			$ttlbol = true;
			break;
		case 2:
			if (is_array($result) && array_key_exists(7, $result))
				$forumfirewall_cach_array[7] = $result[7];
			if (is_array($result) && array_key_exists(8, $result))
				$forumfirewall_cach_array[8] = $result[8];
			if (is_array($result) && array_key_exists(6, $result))
				$forumfirewall_cach_array[6] = $result[6]; // md5('user_agent')
			$ttlbol = true;
			break;
		case 3:
			if (is_array($result) && array_key_exists(4, $result))
				$forumfirewall_cach_array[4] = $result[4];  //  'form_token
			if (is_array($result) && array_key_exists(5, $result))
				$forumfirewall_cach_array[5] = $result[5];  //  form tokin time
			break;
	}

	forumfirewall_loadCache($forumfirewall_ip, $forumfirewall_cach_array, $ttlbol);
	unset($forumfirewall_cach_array);
	return;
}
function forumfirewall_loadCache($forumfirewall_ip, $forumfirewall_cach_array, $ttlbol = false) {

	global $modSettings;
	if ($forumfirewall_ip == '') return;
	if (empty($forumfirewall_cach_array)) return;
	if (!is_array($forumfirewall_cach_array)) return;

	$forumfirewall_expire = $stamp = $cache_flag = ''; //  $cache_content
	$cache_content = $cache_peek = array();
	$forumfirewall_expire = 0;
	$stamp = date('Ymd');
	$cache_content = serialize($forumfirewall_cach_array);

	$cache_flag = forumfirewall_checkCache($forumfirewall_ip);
	if ($cache_flag !== false) {
		$cache_peek = forumfirewall_get_cache_content($forumfirewall_ip);
		if (!empty($cache_peek[2]) && ((int) $cache_peek[2] < time()))  // (time() + $ttl)  < time()
			$forumfirewall_expire = (int) $cache_peek[2];
		else //  New Cache challenged(5 min) or normal(modsetting)
			$forumfirewall_expire = (((bool) $ttlbol) ? 5 * 3600 : (int) $modSettings['forumfirewall_cache_duration']);

		if (!empty($forumfirewall_cach_array[3]) && ($forumfirewall_cach_array[3] === '13'. date('Ymd'))) $forumfirewall_expire =  $forumfirewall_cach_array[2];  //  Passed challenge
	} else //  New Cache challenged(5 min) or normal(modsetting)
		$forumfirewall_expire = (((bool) $ttlbol) ? 5 * 3600 : (int) $modSettings['forumfirewall_cache_duration']);

	unset($cache_peek);

	$forumfirewall_ip = forumfirewall_ip2DB($forumfirewall_ip);

	if (function_exists('hash')) {
		$forumfirewall_algo = forumfirewall_get_hash($stamp);
		forumfirewall_cache_put_data(hash($forumfirewall_algo,serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt'].$stamp)), $cache_content, $forumfirewall_expire);
	} else
		forumfirewall_cache_put_data(sha1(serialize(base64_encode($forumfirewall_ip).$modSettings['forumfirewall_salt'])), $cache_content, $forumfirewall_expire); //  replaced md5 with sha1 40-length > 34-length ip bin

	$forumfirewall_expire = $stamp = null;
	unset($cache_content);
	return;
}
function queryspecialchars($forumfirewall_conv_dta) {

	if ($forumfirewall_conv_dta == '') return;
	if (empty($forumfirewall_conv_dta)) return;

	if (forumfirewall_is_utf8($forumfirewall_conv_dta))
		$forumfirewall_conv_dta = forumfirewall_my_utf8_decode($forumfirewall_conv_dta);

	$forumfirewall_conv_dta = str_ireplace(array('%3C','<','&lt','&#60;','&#060;','&#0060;','&#00060;','&#000060;','&#0000060;','&#60','&#060','&#0060','&#00060','&#000060','&#0000060','&#x3c;','&#x03c;','&#x003c;','&#x0003c;','&#x00003c;','&#x000003c;','&#x3c','&#x03c','&#x003c','&#x0003c','&#x00003c','&#x000003c','\x3c','\u003c','PA=='), '&lt;', $forumfirewall_conv_dta);
	$forumfirewall_conv_dta = str_ireplace(array('%3E','>','&gt','&#62;','&#062;','&#0062;','&#00062;','&#000062;','&#0000062;','&#62','&#062','&#0062','&#00062','&#000062','&#0000062','&#x3e;','&#x03e;','&#x003e;','&#x0003e;','&#x00003e;','&#x000003e;','&#x3e','&#x03e','&#x003e','&#x0003e','&#x00003e','&#x000003e','\x3e','\u003e','PG=='), '&gt;', $forumfirewall_conv_dta);
	$forumfirewall_conv_dta = str_ireplace(array('%3F','&#63;','&#063;','&#0063;','&#00063;','&#000063;','&#0000063;','&#63','&#063','&#0063','&#00063','&#000063','&#0000063','&#x3f;','&#x03f;','&#x003f;','&#x0003f;','&#x00003f;','&#x000003f;','&#x3f','&#x03f','&#x003f','&#x0003f','&#x00003f','&#x000003f','\x3f','\u003f','PW=='), '?', $forumfirewall_conv_dta);
	$forumfirewall_conv_dta = str_ireplace(array('%5C','&#92;','&#092;','&#0092;','&#00092;','&#000092;','&#0000092;','&#92','&#092','&#0092','&#00092','&#000092','&#0000092','&#x5c;','&#x05c;','&#x005c;','&#x0005c;','&#x00005c;','&#x000005c;','&#x5c','&#x05c','&#x005c','&#x0005c','&#x00005c','&#x000005c','\x5c','\u005c','XA=='), '\\', $forumfirewall_conv_dta);
	$forumfirewall_conv_dta = strtoupper($forumfirewall_conv_dta);
	return $forumfirewall_conv_dta;
}
if (!function_exists('str_ireplace')) {
	function str_ireplace($search, $replace, $subject) {
		if (is_array($search)) {
			$words = array();
			foreach ($search as $word) {
				$words[] = '/' . $word . '/i'; }
			unset($word);
		} else {
			$words = '';
			$words = '/' . $search . '/i'; }
		return preg_replace($words, $replace, $subject);
}	}
function forumfirewall_check_ip4($forumfirewall_ip) {

	global $modSettings, $user_info;

	if ($forumfirewall_ip == '') return true;
  	if (empty($forumfirewall_ip)) return true;
  	if (ip2long($forumfirewall_ip) == -1) return true;

	$octet = '';
	$octet = explode('.', $forumfirewall_ip);
	if (count($octet) !== 4)
		return true;
	if ($octet[0][0] == '0')
			return true;
	for ($i = 0; $i < 4; $i++) {
		if (!is_numeric($octet[$i]))
			return true;
		if(strlen($octet[$i]) > 3)
			return true;
		if ((int) $octet[$i] < 0 || (int) $octet[$i] > 255)
			return true;
	}

	if (!$modSettings['forumfirewall_enable_admin'] || ($modSettings['forumfirewall_enable_admin'] && $user_info['is_admin'] && ((forumfirewall_ip2Bin('127.0.0.1') != forumfirewall_ip2Bin($modSettings['forumfirewall_admin_ip_lo'])) && (forumfirewall_ip2Bin('127.0.0.1') != forumfirewall_ip2Bin($modSettings['forumfirewall_admin_ip_hi']))))) {

		$ip_min = $ip_max = '';
		$reserved_ip = array(
			array('0.0.0.0','0.255.255.255'),
			array('10.0.0.0','10.255.255.255'),
			array('127.0.0.0','127.255.255.255'),
			array('169.254.0.0','169.254.255.255'),
			array('172.16.0.0','172.31.255.255'),
			array('192.0.2.0','192.0.2.255'),
			array('192.88.99.0','192.88.99.255'),
			array('192.168.0.0','192.168.255.255'),
			array('198.18.0.0','198.19.255.255'),
			array('198.51.100.0','198.51.100.255'),
			array('203.0.113.0','203.0.113.255'),
			array('224.0.0.0','239.255.255.255'),
			array('240.0.0.0','255.255.255.255'),
		);

		foreach ($reserved_ip as $limit) {
			$ip_min = ff_ip2long($limit[0]);
			$ip_max = ff_ip2long($limit[1]);

			if ((ff_ip2long($forumfirewall_ip) >= $ip_min) && (ff_ip2long($forumfirewall_ip) <= $ip_max)) {
				unset($limit);
				return true;
		}	}
		unset($limit); }

	if (@version_compare(PHP_VERSION, '5.2.0') != -1) {
		if(!filter_var($forumfirewall_ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4))
  			return true; }

	return false;
}
function forumfirewall_check_ip6($forumfirewall_ip) {
	global $modSettings, $user_info;

	if ($forumfirewall_ip == '') return true;
  	if (empty($forumfirewall_ip)) return true;


	$ff_elements = array();
	$ff_elements = forumfirewall_divide($forumfirewall_ip);
	$forumfirewall_ipaddr = $ff_bitmask = '';

	$forumfirewall_ipaddr = $ff_elements[0];
	$ff_bitmask = $ff_elements[1];

	if(($ff_bitmask !== '') && (!is_numeric($ff_bitmask) || ((int) $ff_bitmask < 0) || ((int) $ff_bitmask > 128)))
			return true;

	// Check for ipv4 component
	$forumfirewall_ipPart = forumfirewall_return64($forumfirewall_ipaddr);
	if (!empty($forumfirewall_ipPart[1])) {
		if ($forumfirewall_check_ip4($forumfirewall_ipPart[1]) !== false)
			return true;
		else
			return false;  // ipv4 passed
	}

	$forumfirewall_ipaddr = strtolower($forumfirewall_ipPart[0]);

	if (!empty($forumfirewall_ipaddr)) {
		$forumfirewall_ipv6 = array();
		$forumfirewall_ipv6 = explode(':', $forumfirewall_ipaddr);
		foreach($forumfirewall_ipv6 as $element) {
			if(!(preg_match('/[0-9a-f]*/', $element) === 1)) {
				unset($element);
				return true;
			}
		unset($element);
		}

		$octet = $ff_prefix = '';
		if(preg_match('!^[a-f0-9:]{1,39}$!i', $forumfirewall_ipaddr) === 1) {
			$octet = explode(':::', $forumfirewall_ipaddr);
			if(count($octet) > 1)
				return true;
			$octet = explode('::', $forumfirewall_ipaddr);
			if(count($octet) > 2)
				return true;
			$octet = explode(':', $forumfirewall_ipaddr);
			if(count($octet) > 8)
				return true;

			foreach($octet as $checkPart) {
				if(strlen($checkPart) > 4) {
					unset($checkPart);
					return true;
			}	}
			unset($checkPart);

			$forumfirewall_Cip = forumfirewall_compressip6($forumfirewall_ip);

			if ((!$modSettings['forumfirewall_enable_admin']) || (($modSettings['forumfirewall_enable_admin']) && ($user_info['is_admin']) && ((strcmp(forumfirewall_compressip6($modSettings['forumfirewall_admin_ip_lo']), '::1') == 0) && (strcmp(forumfirewall_compressip6($modSettings['forumfirewall_admin_ip_hi']), '::1'))))) {
				if ((strcmp($forumfirewall_Cip, '::1') == 0) || (strcmp($forumfirewall_Cip, '::1/128') == 0)) return true;  //  Local addresses
			}
			if ((strcmp($forumfirewall_Cip, '::') == 0) || (strcmp($forumfirewall_Cip, '::/128') == 0)) return true;  //  Unspecified address
			if ((strcmp($forumfirewall_Cip, '::/0') == 0)) return true;  // Default route

			if (strlen($forumfirewall_ipaddr) >= 2) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 2);
				if (strcmp($ff_prefix, 'ff') == 0) return true;
				if ((strcmp($ff_prefix, 'fc') == 0) || (strcmp($ff_prefix, 'fd') == 0)) return true;
				if (strcmp($ff_prefix, '5f') == 0) return true;
			}
			if (strlen($forumfirewall_ipaddr) >= 3) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 3);
				if ((strcmp($ff_prefix, 'fe8') == 0) || (strcmp($ff_prefix, 'fe9') == 0) || (strcmp($ff_prefix, 'fea') == 0) || (strcmp($ff_prefix, 'feb') == 0)) return true;  // Local addresses
				if ((strcmp($ff_prefix, 'fec') == 0) || (strcmp($ff_prefix, 'fed') == 0) || (strcmp($ff_prefix, 'fee') == 0) || (strcmp($ff_prefix, 'fef') == 0)) return true;
			}

			if (strlen($forumfirewall_ipaddr) >= 4) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 4);
				if (strcmp($ff_prefix, '3ff3') == 0) return true;
			}

			if (strlen($forumfirewall_ipaddr) >= 7) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 7);
				if (strcmp($ff_prefix, '2001:1:') == 0) return true;
			}

			if (strlen($forumfirewall_ipaddr) >= 8) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 8);
				if (strcmp($ff_prefix, '2001:001') == 0) return true;
			}

			if (strlen($forumfirewall_ipaddr) >= 9) {
				$ff_prefix = substr($forumfirewall_ipaddr, 0, 9);
				if ((strcmp($ff_prefix, '2001:0db8') == 0) || (strcmp($ff_prefix, '2001:db8:') == 0)) return true;
			}
			$ff_prefix = null;

			if (@version_compare(PHP_VERSION, '5.2.0') != -1) {
				if(!filter_var($forumfirewall_ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6))
  					return true;
				if(!filter_var($forumfirewall_ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
  					return true;
				if(!filter_var($forumfirewall_ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_RES_RANGE))
  					return true;
			}
		return false;
	}	}
	return true;
}
function forumfirewall_checkdns($forumfirewall_ip, $forumfirewall_domain) { 
	if ($forumfirewall_ip == '') return true;
  	if (empty($forumfirewall_ip)) return true;
	if (empty($forumfirewall_domain)) return true;
	if (!function_exists('is_callable')) return true;
	if ((!is_callable('gethostbyaddr')) || (!is_callable('dns_get_record'))) return true;

	$pos = false;
	$name = gethostbyaddr($forumfirewall_ip);   // web site name
	if ($forumfirewall_ip === $name) return $pos;  //  failure

	$pos = strpos(strrev($name), strrev($forumfirewall_domain));
	if ($pos !== false) {
		$host = @ff_gethostbynamel($name, true);  //  ipv4 and ipv6 safe address

		$forumfirewall_ip_test = $forumfirewall_ip_host = '';
		//  Make an ipv4 or ipv6 binary
		$forumfirewall_ip_test = forumfirewall_ip2Bin($forumfirewall_ip);
		if (($host !== false) && (!empty($host)) && is_array($host)) {
			if (count($host) !== 0) {
				foreach ($host as $hosts) {
					if (!empty($hosts)) {
						$forumfirewall_ip_host = forumfirewall_ip2Bin($hosts);
    					if ((strlen($forumfirewall_ip_host) == strlen($forumfirewall_ip_test)) && (strcasecmp($forumfirewall_ip_host, $forumfirewall_ip_test) == 0)) {
						$pos = true;
						break;
			}	}	}	}
			unset($hosts);
		} else {
		 	if (strcasecmp(forumfirewall_ip2Bin($host), $forumfirewall_ip_test) == 0)
				$pos = true;
	}	}
	return $pos;
}
// IPv4 Address ABS(Number)
function ff_ip2long($forumfirewall_ip) {
    $forumfirewall_ip = trim($forumfirewall_ip);

    if (forumfirewall_IPv4orIPv6($forumfirewall_ip) !== false) return '0';

    return sprintf('%u', ip2long($forumfirewall_ip));  
}
// Get AAAA or A records for host
function ff_gethostbynamel($ff_host, $try_a = false) {

	$dns6 = dns_get_record($ff_host, DNS_AAAA);
	if ($try_a == true) {
		$dns4 = dns_get_record($ff_host, DNS_A);
		$dns = array_merge($dns4, $dns6);
	} else
		$dns = $dns6;

	$ip4 = $ip6 = array();
	foreach ($dns as $record) {
		if ($record['type'] == 'A')
			$ip4[] = $record['ip'];

		if ($record['type'] == 'AAAA')
			$ip6[] = $record['ipv6'];
	}
	unset($record);

	if (count($ip6) < 1) {
		if ($try_a == true) {
			if (count($ip4) < 1)
				return false;
			else
				return $ip4;

		} else
			return false;

	} else
		return $ip6;
}
//  If log is enabled I will load the package and log in the database then send to error screen
function forumfirewall_block($forumfirewall_data, $result) {
	global $modSettings, $sourcedir, $boarddir, $webmaster_email, $txt;
	if (function_exists('loadlanguage')) {
		if(loadlanguage('ForumFirewall') === false)
     		 loadLanguage('ForumFirewall');
	} else {
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
		if(loadlanguage('ForumFirewall') === false)
      		loadLanguage('ForumFirewall'); }

	$result_temp = $request_uri = $forumfirewall_test_result = '';

	if ($forumfirewall_data['sql_reason'] == '999')
		$forumfirewall_data['sql_reason'] = $txt['forumfirewall_sql_reason'];
	if ($result[0] == '1')
		$result_temp = $txt['result1'];
	if ($result[0] == '2') {
		if ($forumfirewall_data['sql_reason'] == '100') {
			$result_temp = $txt['result2'] . $txt['forumfirewall_reason0'] . $txt['result0'];
		} else
			$result_temp = $txt['result2'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	}
	if ($result[0] == '3')
		$result_temp = $txt['result3'];

	if ($modSettings['forumfirewall_enable_block'] && (($result[0] == '4' && $modSettings['forumfirewall_enable_challenge']) && (!isset($result[1]) || (isset($result[1]) && (int) $result[1] <= 3))) || ($result[0] == '5' && $modSettings['forumfirewall_challenge_country'])) {
		// start challenge

		// Attempt to remove PHPSESSID from scripturl
		@ini_set('session.use_trans_sid', "0");

		if ((@version_compare(PHP_VERSION, '5.2.0') != -1) && function_exists('imagecreate')  && (isset($modSettings['forumfirewall_cache_duration'])) && (!empty($modSettings['forumfirewall_cache_duration'])) && (((int) $modSettings['forumfirewall_cache_duration']) !== 0)) {

			//  Was challenge conducted
			$forumfirewall_cach_array = array();
			$forumfirewall_cach_array = forumfirewall_get_cache_content($forumfirewall_data['visitor_ip']);
			if (is_array($forumfirewall_cach_array) && array_key_exists(7, $forumfirewall_cach_array))
				$result[7] = $forumfirewall_cach_array[7];
			if (is_array($forumfirewall_cach_array) && array_key_exists(8, $forumfirewall_cach_array))
				$result[8] = $forumfirewall_cach_array[8];
			If (is_array($forumfirewall_cach_array) && array_key_exists(6, $forumfirewall_cach_array))
				$result[6] = $forumfirewall_cach_array[6];
			if (is_array($forumfirewall_cach_array) && array_key_exists(4, $forumfirewall_cach_array))
				$result[4] = $forumfirewall_cach_array[4];
			if (is_array($forumfirewall_cach_array) && array_key_exists(5, $forumfirewall_cach_array))
				$result[5] = $forumfirewall_cach_array[5];
			unset($forumfirewall_cach_array);
			//  Challenge visitor
			if (!function_exists('forumfirewall_Challenge'))
				require_once($sourcedir . DIRECTORY_SEPARATOR . 'ForumFirewall_Challenge.php');
			if (!isset($result[4], $result[5])) {
				if (!defined('FF_CHARS')) define('FF_CHARS', 100);
				forumfirewall_savecache($forumfirewall_data, $result, 1);  //  save UA & remote address 
				forumfirewall_Challenge();
				//  Was challenge conducted
				$forumfirewall_cach_array = array();
				$forumfirewall_cach_array = forumfirewall_get_cache_content($forumfirewall_data['visitor_ip']);
				if (is_array($forumfirewall_cach_array) && array_key_exists(7, $forumfirewall_cach_array))
					$result[7] = $forumfirewall_cach_array[7];
				if (is_array($forumfirewall_cach_array) && array_key_exists(8, $forumfirewall_cach_array))
					$result[8] = $forumfirewall_cach_array[8];
				If (is_array($forumfirewall_cach_array) && array_key_exists(6, $forumfirewall_cach_array))
					$result[6] = $forumfirewall_cach_array[6];
				if (is_array($forumfirewall_cach_array) && array_key_exists(4, $forumfirewall_cach_array))
					$result[4] = $forumfirewall_cach_array[4];
				if (is_array($forumfirewall_cach_array) && array_key_exists(5, $forumfirewall_cach_array))
					$result[5] = $forumfirewall_cach_array[5];
				unset($forumfirewall_cach_array);
			}
			// Validate challenge
			$forumfirewall_test_result = '';
			$forumfirewall_test_result = date('Ymd');

			if (!empty($result[4]) && !empty($result[5])
				&& (isset($result[4], $result[5]))
				&& (((time() - (int) $result[5]) < 10800)) && ($result[4] == $forumfirewall_test_result)) { 
					//  pass if page moves in 3 hours
					$result[0] = '15';  //  Try to save to cache before leaving
					$result[2] = time() + 86400;  // 24 hours
					$result[3] = '13'. date('Ymd');
				} else {
					//  make fail first time and henceforth
					$result[0] = ((isset($result[1]) && ((int) $result[1] > 1)) ? '4' : '15');
					$result[2] = null;
					$result[3] = (empty($result[4]) ? (empty($result[3]) ? ((isset($result[1]) && ((int) $result[1] > 1)) ? '8564502638' : '0') : $result[3]) : $result[4]);
				}
		//  end challenge
		}
	} elseif ($result[0] == '4')
		$result_temp = $txt['result4'] . (!empty($forumfirewall_data['sql_reason']) ? $txt['forumfirewall_colin'] . forumfirewall_xss_safe ($forumfirewall_data['sql_reason']) : '') . $txt['result0'];
	elseif ($result[0] == '5')
		$result_temp = $txt['result5'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];

	if ($result[0] == '6')
		$result_temp = $txt['result6'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if ($result[0] == '7')
		$result_temp = $txt['result7'];
	if ($result[0] == '8')
		$result_temp = $txt['result8'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if ($result[0] == '9')
		$result_temp = $txt['result9'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if ($result[0] == '10')
		$result_temp = $txt['result10'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if (($result[0] == '11') || ($result[0] == '12'))
		$result_temp = $txt['result11'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if ($result[0] == '13')
		$result_temp = $txt['result13'] . forumfirewall_xss_safe($forumfirewall_data['sql_reason']) . $txt['result0'];
	if ($result[0] == '14')
		$result_temp = $txt['result14'];
	if ($result[0] == '15')
		$result_temp = $txt['result15'] . (((empty($result[3])) || ($result[3] == '13'. date('Ymd'))) ? '' : $txt[$result[3]]);

	if (!empty($modSettings['forumfirewall_logging']) && ($modSettings['forumfirewall_logging']) &&
		(($result[0] == '15') && ((!empty($result[3])) && ($result[3] === '13'. date('Ymd'))))) {
		$result_temp = $txt['result15a'];
		//  Log passed challenge
			forumfirewall_db_query(forumfirewall_insert_challenge($forumfirewall_data, $result_temp));

		//  Cookie not needed
		if(isset($_COOKIE['ff_token'])) forumfirewall_clear_cookie(true);

		//  Passed challenge so correct cache to prevent duplicate db entries
		$forumfirewall_cach_array = array();
		$forumfirewall_cach_array[0] = 'false';
		$forumfirewall_cach_array[1] = $result[1];
		$forumfirewall_cach_array[3] = 'na';
		forumfirewall_savecache($forumfirewall_data, $forumfirewall_cach_array);
		unset($forumfirewall_cach_array);

	} elseif ((!empty($modSettings['forumfirewall_logging']) && ($modSettings['forumfirewall_logging']) && 
		($result[0] !== '15')) || (!empty($modSettings['forumfirewall_logging']) && 
		($modSettings['forumfirewall_logging']) && (($result[0] == '15') && 
		((!empty($result[3])) && ($result[3] !== '13'. date('Ymd'))))))
		{
			if(((!empty($modSettings['forumfirewall_enable_challenge']) && $modSettings['forumfirewall_enable_block'] && $modSettings['forumfirewall_enable_challenge']) || (!empty($modSettings['forumfirewall_challenge_country']) && $modSettings['forumfirewall_enable_block'] && $modSettings['forumfirewall_challenge_country'])) && (($result[0] == '15') || ($result[0] == '4' && (int) $result[1] >= 2))) {  //  $result[0] == '4' part of challenge
				if ($result[0] == '4' && (int) $result[1] == 2) {
					$result_temp = $txt['result15']. $txt['result1'];
					//  Log failed challenge
					forumfirewall_db_query(forumfirewall_insert_challenge($forumfirewall_data, $result_temp));
				} elseif ($result[0] == '4' && (int) $result[1] >= 3) {
					$result_temp = $txt['result15']. $txt['forumfirewall_sql_reason']. $txt['result0'];
					// Log a violation
					forumfirewall_db_query(forumfirewall_insert($forumfirewall_data, $result_temp));
				} else //  Log failed challenge
					if (strpos($result_temp, $txt['forumfirewall_sql_reason']) !== false)
						forumfirewall_db_query(forumfirewall_insert($forumfirewall_data, $result_temp));
					else
						forumfirewall_db_query(forumfirewall_insert_challenge($forumfirewall_data, $result_temp));

				//  Cookie not needed
				if (isset($_COOKIE['ff_token'])) forumfirewall_clear_cookie(true);

				//  Failed challenge so correct cache to allow repeated
				$forumfirewall_cach_array = array();
				$forumfirewall_cach_array[0] = (($result[0] == '15') ? '4' : $result[0]);  //  Force repeat on failed challenge
				$forumfirewall_cach_array[1] = $result[1];
				$forumfirewall_cach_array[3] = 'forumfirewall_sql_reason';
				forumfirewall_savecache($forumfirewall_data, $forumfirewall_cach_array);
				unset($forumfirewall_cach_array);
			} else {
				if ($result[0] == '4' && array_key_exists('1', $result))
					$result_temp = $txt['result4']. $txt['forumfirewall_colin']. forumfirewall_xss_safe($txt['forumfirewall_sql_reason']). $txt['result0'];
				// Log a unchallenged violation
				forumfirewall_db_query(forumfirewall_insert($forumfirewall_data, $result_temp));
		}	}

	//  Send a message
	$request_uri = forumfirewall_xss_safe($forumfirewall_data['request_uri']);
	if (!empty($modSettings['forumfirewall_enable_email']) && (!defined('FF_MSG_SENT'))) {
		if ((($modSettings['forumfirewall_enable_email'] == 1) && ($result[0] == '3')) || 
			(($modSettings['forumfirewall_enable_email'] == 2) && ($result[0] !== '15')) ||
				(($modSettings['forumfirewall_enable_email'] == 2) && (($result[0] == '15') && ((!empty($result[3])) && ($result[3] !== '13'. date('Ymd')))))
				)
				forumfirewall_email($request_uri, $result_temp, $forumfirewall_data['visitor_ip']);
				define('FF_MSG_SENT', 2); //   No duplicates for same ip session
	}

	//  Try to save to cache
	if ((isset($modSettings['forumfirewall_cache_duration'])) && (!empty($modSettings['forumfirewall_cache_duration'])) && (((int) $modSettings['forumfirewall_cache_duration']) !== 0)) {
		if ($result[0] !== '15') { // && ((!empty($result[3])) && ($result[3] === '13'. date('Ymd'))))) {
			if (empty($result[1]))
				$result[1] = '1';
			else
				$result[1] = (int) $result[1] + 1;
			if (empty($result[2]))
				$result[2] = time();
			forumfirewall_savecache($forumfirewall_data, $result, 0);
		}
	} else {
		if (((int) $modSettings['forumfirewall_cache_duration']) !== 0) {
			if (function_exists('loadlanguage')) {
				if(loadlanguage('Errors') === false)
   		  		 	loadLanguage('Errors');
			} else {
				require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
				if(loadlanguage('Errors') === false)
   		   			loadLanguage('Errors'); }

			log_error($txt['cfcache'], 'user'); } }

	//  BAN DOS thru SMF
	if ($result[0] == '3') {
		if ($modSettings['forumfirewall_enable_block'] && !empty($modSettings['forumfirewall_longterm_ban']) && ((int) $modSettings['forumfirewall_longterm_ban'] !== 0)) {
			forumfirewall_ip_ban($forumfirewall_data, $result_temp);
  			//  Try to eliminate duplicates 
			sleep(5); }	}

	//  Do not tell them why
	if (($result[0] == '2') || ($result[0] == '9'))
		$result_temp = $txt['result2a'];
	if ($result[0] == '6')
		$result_temp = $txt['result6a'];
	if (($result[0] == '7') || ($result[0] == '10'))
		$result_temp = $txt['result7'];
	if ($result[0] == '8')
		$result_temp = $txt['result4'] . $txt['result0'];
	if ($result[0] == '15')
		$result_temp = 	$txt['result15'];

	//  Good bye
	if ($modSettings['forumfirewall_enable_block']) {
		if (($result[0] !== '15') || (($result[0] == '15') && ((!empty($result[3])) && ($result[3] !== '13'. date('Ymd'))))) {
		$webmaster_nospam = $webmaster_at = $honeyLink = $maxnum = '';
		$webmaster_nospam = forumfirewall_obfuscate(forumfirewall_xss_safe($webmaster_email));
		$webmaster_at = $txt['forumfirewall_theadmin'];
		if(stristr($forumfirewall_data['user_agent'], 'Mediapartners-Google') || stristr($forumfirewall_data['user_agent'], 'Googlebot') || stristr($forumfirewall_data['user_agent'], 'Google Web Preview') || stristr($forumfirewall_data['user_agent'], 'AdsBot-Google') || stristr($forumfirewall_data['user_agent'], 'Googlebot-News') || stristr($forumfirewall_data['user_agent'], 'Googlebot-Image') || stristr($forumfirewall_data['user_agent'], 'Googlebot-Video') || stristr($forumfirewall_data['user_agent'], 'Googlebot-Mobile') || stristr($forumfirewall_data['user_agent'], 'Mediapartners')) $maxnum=10;
		$honeyLink = forumfirewall_honeyLink($maxnum);
		unset($result);
		unset($forumfirewall_data);
		define('FFW', dirname(__FILE__));
		require_once($boarddir . DIRECTORY_SEPARATOR . 'ff_firewall.php');
		forumfirewall_display_block($honeyLink, $request_uri, $result_temp, $webmaster_nospam, $webmaster_at);
		die();
	}	}
	return;
}
function forumfirewall_honeyLink($maxnum = 18) {
	global $modSettings;
	$forumfirewall_httpbl_link = $forumfirewall_httpbl_word = '';
	$forumfirewall_httpbl_word = 'login';

	if (empty($maxnum)) $maxnum = 18;
	if (empty($modSettings['badbehavior_httpbl_link']))	{
		if (empty($modSettings['httpBL_honeyPot_link']))
			return '';
		else {
			$forumfirewall_httpbl_link = $modSettings['httpBL_honeyPot_link'];
			if (!empty($modSettings['httpBL_honeyPot_word']))
				$forumfirewall_httpbl_word = $modSettings['httpBL_honeyPot_word'];
		}
	} else {
		$forumfirewall_httpbl_link = $modSettings['badbehavior_httpbl_link'];
		if (!empty($modSettings['badbehavior_httpbl_word']))
			$forumfirewall_httpbl_word = $modSettings['badbehavior_httpbl_word'];
	}

	$ff_cvalue = true;
	mt_srand(forumfirewall_make_seed($ff_cvalue));
	$ff_cvalue = null;

	switch (mt_rand(0, $maxnum)) {
		case 0:
			return '<a href="'. $forumfirewall_httpbl_link .'"><!-- '. $forumfirewall_httpbl_word .' --></a>';
		case 1:
			return '<a href="'. $forumfirewall_httpbl_link .'"></a>';
		case 2:
			global $boardurl;
			return '<img src="'. $boardurl. '/Themes/default/images/'. 'blank.gif" alt="image" usemap="#Map" border="0" width="1" height="1" /><map name="Map" /><area shape="rect" coords="5,-49,35,-4" href="'. $forumfirewall_httpbl_link .'" alt="'. $forumfirewall_httpbl_word .'" /></map>';
		case 3:
			return '<!-- <a href="'. $forumfirewall_httpbl_link .'">'. $forumfirewall_httpbl_word .'</a> -->';
		case 4:
			global $boardurl;
			return '<a href="'. $forumfirewall_httpbl_link .'"><img src="'. $boardurl. '/Themes/default/images/'. 'blank.gif" alt="'. $forumfirewall_httpbl_word .'" border="0" height="1" width="1" /></a>';
		case 5:
			return '<div style="position: absolute; top: -370px; left: -370px;"><a href="'. $forumfirewall_httpbl_link .'">'. $forumfirewall_httpbl_word .'</a></div>';
		case 6:
			return '<a href="'. $forumfirewall_httpbl_link .'"><font style="font-family: sans-serif;"></font></a>';
		case 7:
			return '<a href="'. $forumfirewall_httpbl_link .'">&#160</a>';
		case 8:
			return '<a href="'. $forumfirewall_httpbl_link .'">&#x00A0</a>';
		case 9:
			return '<a href="'. $forumfirewall_httpbl_link .'"><img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==" alt="'. $forumfirewall_httpbl_word .'" border="0" height="1" width="1" /></a>';
		case 10:
			return '<span style="position:absolute;top:-450px;left:-450px;"><a href="'. $forumfirewall_httpbl_link .'">'. $forumfirewall_httpbl_word .'</a></span>';
		case 11:
			return '<a style="cursor: text; text-decoration: none;" href="'. $forumfirewall_httpbl_link .'">&nbsp;</a>';
		case 12:
			return '<a href="'. $forumfirewall_httpbl_link .'"><div style="height: 0px; width: 0px;"></div></a>';
		case 13:
			return '<a href="'. $forumfirewall_httpbl_link .'" style ="color: #fff;">'. $forumfirewall_httpbl_word .'</a>';
		case 14:
			return '<a href="'. $forumfirewall_httpbl_link .'" style ="visibility: hidden; height: 0px; width: 0px;">'. $forumfirewall_httpbl_word .'</a>';
		case 15:
			return '<a href="'. $forumfirewall_httpbl_link .'"><span style="display: none;">'. $forumfirewall_httpbl_word .'</span></a>';
		case 16:
			return '<img src="'. $forumfirewall_httpbl_link .'" alt="'. $forumfirewall_httpbl_word .'" width="0" height="0" />';
		case 17:
			return '<a href="'. $forumfirewall_httpbl_link .'" style="display: none;">'. $forumfirewall_httpbl_word .'</a>';
		case 16:
			return '<div style="display: none;"><a href="'. $forumfirewall_httpbl_link .'">'. $forumfirewall_httpbl_word .'</a></div>';
		default:
			return '<!-- <a href="'. $forumfirewall_httpbl_link .'">'. $forumfirewall_httpbl_word .'</a> -->';
	}
}
function forumfirewall_make_seed($ff_cvalue) {
	if (empty($ff_cvalue)) return null;
	list($usec, $sec) = explode(' ', microtime());
	return (float) $sec + ((float) $usec * 100000);
}
function forumfirewall_obfuscate($webmaster_email) {
	global $txt, $sourcedir;

	if (function_exists('loadlanguage')) {
		if(loadlanguage('ForumFirewall') === false)
     		 loadLanguage('ForumFirewall');
	} else {
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
		if(loadlanguage('ForumFirewall') === false)
      		loadLanguage('ForumFirewall'); }

	$stamp = date('Ymd');
	$webmaster_nospam  = $email = $encoding = $x = '';
	$search = array('@','.', '-');
	$replace = array($txt['forumfirewall_nospam'], $txt['forumfirewall_dot'], $txt['forumfirewall_dash']);
	$characters = array('0','0000','00','00000','000', '00000', '000','00','0000','0');

	$webmaster_nospam = $txt['forumfirewall_mailto'].str_replace($search, $replace, forumfirewall_xss_safe($webmaster_email));

	$ff_cvalue = true;
	mt_srand(forumfirewall_make_seed($ff_cvalue));
	$ff_cvalue = null;
	$x = mt_rand(0, (count($characters)-1));
	$encoding = $characters[$x];

	if ($stamp  % 2) {
		for ($i = 0, $email_lng = strlen($webmaster_nospam); $i < $email_lng; $i++) {
			$email .= '&#' . $encoding . ord($webmaster_nospam[$i]). ';'; }

 	} else {
		for ($i = 0, $email_lng = strlen($webmaster_nospam); $i < $email_lng; $i++) {
			$email .= '&#x' .$encoding . base_convert(ord($webmaster_nospam[$i]), 10, 16). ';'; }
			//  64 bit compatibility was $email .= '&#x' .$encoding . dechex(ord($webmaster_nospam[$i])). ';'; }
	}
	$webmaster_nospam = $email;

	$email_lng = $email = null;
//	unset($search, $replace, $characters);  // Arrays too small

	return $webmaster_nospam ;
}
function forumfirewall_email($request_uri, $result_temp, $ip_temp) {
	global $modSettings, $sourcedir, $webmaster_email, $txt;
	if (function_exists('loadlanguage')) {
		if(loadlanguage('ForumFirewall') === false)
     		 loadLanguage('ForumFirewall');
	} else {
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
		if(loadlanguage('ForumFirewall') === false)
      		loadLanguage('ForumFirewall'); }

	if (empty($request_uri)) return;
	if (empty($result_temp)) return;

	$emailsubject = $emailbody = '';
	require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs-Post.php');

	$emailsubject = $txt['forumfirewall'] . $txt['forumfirewall_block'];
	$emailbody = " " . $txt['forumfirewall_ip'] . $ip_temp . ", " . forumfirewall_xss_safe($result_temp) . "\n\r";
	$emailbody .= $txt['forumfirewall_for'] . forumfirewall_xss_safe($request_uri) . "\n\r";
	sendmail($webmaster_email, $emailsubject, $emailbody, null, null, false, 3, null, false);
}
function forumfirewall_db_query($query) {
	global $smcFunc;

	if ((!isset($query)) || (empty($query))) return false;
	$link = $smcFunc['db_query']($query);
	if (!isset($link) || empty($link)) return false;
	if ($link === true) {
		$affected_rows = $smcFunc['db_affected_rows']();
		if ($affected_rows >= 1)
			return true;
		else
			return false;
	} else {
		$number_of_rows = $smcFunc['db_num_rows']($link);
		if ($number_of_rows == '0')
			return false;
	}
	$qresult = forumfirewall_db_rows($link);
	return $qresult;
}
function forumfirewall_db_rows($linkid) {
	global $smcFunc;

	if (empty($linkid)) return false;
	if (!is_array($linkid)) return false;
	$qresult = array();
	$i = 0;
	while($row = $smcFunc['db_fetch_assoc']($linkid)) {
		$qresult[$i] = $row;
    	$i++; }
	if (empty($qresult))
		$qresult = $linkid;
	$smcFunc['db_free_result']($linkid);
	return $qresult;
}
function forumfirewall_ip_ban($forumfirewall_data, $result_temp) {

	$forumfirewall_ip = '';
	$forumfirewall_ip = $forumfirewall_data['visitor_ip'];

	//  Banning IPv6 in SMF will not work since SMF is not IPv6 compatible so return
	if (forumfirewall_IPv4orIPv6($forumfirewall_ip) !== false) return;

	global $modSettings, $smcFunc, $sourcedir;

	if (!function_exists('timeformat'))
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs.php');

	$request = $bantime = $banexpire = '';
	$remoteinfo = $row = $octet = array();
	$bannedBefore = false;
	$bantime = time(); //  Ban to cool off
	$banDate = timeformat((int) $bantime);

	switch ((int) $modSettings['forumfirewall_longterm_ban']) {
	case 0:
		return; //  Should not be here
	break;
	case 1:
		$banexpire = $bantime + 3600;  //  1 hr not possible SMF 2.0 :(
	break;
	case 2:
		$banexpire = $bantime + 86400;
	break;
	case 3:
		$banexpire = $bantime + 604800;
	break;
	case 4:
		$banexpire = null;
	break;
	default:
		$banexpire = $bantime + 3600;
	break; }

	// Let's not allow XSS in ban names, it's more evil than beneficial.
	$forumfirewall_ip = forumfirewall_xss_safe($forumfirewall_ip);

	$qresult = $smcFunc['db_query']('', '
		SELECT id_ban_group, expire_time, notes
		FROM {db_prefix}ban_groups
		WHERE name = {string:ipofuser}
		LIMIT 1',
		array(
		'ipofuser' => $forumfirewall_ip,
		)
	);
	if ($smcFunc['db_num_rows']($qresult) > 0) {
		while ($row = $smcFunc['db_fetch_assoc']($qresult)) {
			$remoteinfo['id_ban_group'] = $row['id_ban_group'];
			$remoteinfo['expire_time'] = $row['expire_time'];
			$remoteinfo['notes'] = $row['notes'];
			$bannedBefore = true;
	}	}
	$smcFunc['db_free_result']($qresult);

	if ($bannedBefore) {
		//  Make sure we can access Subs
		if (!function_exists('updateSettings'))
			require_once($sourcedir . DIRECTORY_SEPARATOR . 'Subs.php');

		//  First see if the old ban has expired let ban trigger count it
		if (($remoteinfo['expire_time'] == null) || ((int) $remoteinfo['expire_time'] >= time()))
			return;
		$numberOfViolations = intval(substr($remoteinfo['notes'], 20, 4)) + 1;
		$numberOfViolations = strlen($numberOfViolations) == 1 ? '000'. $numberOfViolations : (strlen($numberOfViolations) == 2 ? '00' . $numberOfViolations : (strlen($numberOfViolations) == 3 ? '0' . $numberOfViolations : (strlen($numberOfViolations) == 4 ? $numberOfViolations :  '0001'))) ;

		$smcFunc['db_query']('', '
				UPDATE {db_prefix}ban_groups
				SET
					name = {string:ban_name},
					reason = {string:reason},
					notes = {string:notes},
					expire_time = {raw:expiration},
					cannot_access = {int:cannot_access},
					cannot_post = {int:cannot_post},
					cannot_register = {int:cannot_register},
					cannot_login = {int:cannot_login}
				WHERE id_ban_group = {int:id_ban_group}',
				array(
					'expiration' => $banexpire,
					'cannot_access' => 1,
					'cannot_post' => 0,
					'cannot_register' => 0,
					'cannot_login' => 0,
					'id_ban_group' => $remoteinfo['id_ban_group'],
					'ban_name' => $forumfirewall_ip,
					'reason' => $result_temp,
					'notes' => 'Multiple Violation: ' . $numberOfViolations . ' updated ' . date('Y-m-d H:i:s'),
				)
			);

		if (!function_exists('banLastUpdated'))
			require_once($sourcedir . DIRECTORY_SEPARATOR . 'ManageBans.php');

		// No more caching, we have something new here.
		updateSettings(array('banLastUpdated' => time()));
		updateBanMembers();

	} else {
		//  Make sure we can access managebans
		if (!function_exists('ip2range'))
			require_once($sourcedir . DIRECTORY_SEPARATOR . 'ManageBans.php');

		$smcFunc['db_insert']('',
			'{db_prefix}ban_groups',
			array(
				'name' => 'string-20',
				'ban_time' => 'int',
				'expire_time' => 'raw',
				'cannot_access' => 'int',
				'cannot_register' => 'int',
				'cannot_post' => 'int',
				'cannot_login' => 'int',
				'reason' => 'string-255',
				'notes' => 'string-65534',
			),
			array(
				$forumfirewall_ip,
				$bantime,
				$banexpire,
				1,
				0,
				0,
				0,
				$result_temp,
				$result_temp .' on: '. date('Y-m-d H:i:s'),
			),
			array('id_ban_group')
		);
		$_REQUEST['bg'] = $smcFunc['db_insert_id']('{db_prefix}ban_groups', 'id_ban_group');

		$ip_parts = ip2range($forumfirewall_ip);
		$ban_triggers[] = array(
			$ip_parts[0]['low'],
			$ip_parts[0]['high'],
			$ip_parts[1]['low'],
			$ip_parts[1]['high'],
			$ip_parts[2]['low'],
			$ip_parts[2]['high'],
			$ip_parts[3]['low'],
			$ip_parts[3]['high'],
			'',
			'',
			0,
		);
		$ban_logs[] = array(
			'ip_range' => $forumfirewall_ip,
		);

		// Now that the ban group is added, add some triggers as well.
		if (!empty($ban_triggers) && !empty($_REQUEST['bg'])) {

			// Put in the ban group ID.
			foreach ($ban_triggers as $k => $trigger)
				array_unshift($ban_triggers[$k], $_REQUEST['bg']);

			$smcFunc['db_insert']('',
				'{db_prefix}ban_items',
				array(
					'id_ban_group' => 'int', 'ip_low1' => 'int', 'ip_high1' => 'int', 'ip_low2' => 'int',
					'ip_high2' => 'int', 'ip_low3' => 'int', 'ip_high3' => 'int', 'ip_low4' => 'int',
					'ip_high4' => 'int', 'hostname' => 'string-255', 'email_address' => 'string-255',
					'id_member' => 'int',
				),
				$ban_triggers,
				array('id_ban')
			);
		}
	} 
	return;
}
function forumfirewall_inspect_system() {
	global $modSettings, $txt, $sourcedir;

	if (function_exists('loadlanguage')) {
		if(loadlanguage('ForumFirewall') === false)
     		 loadLanguage('ForumFirewall');
	} else {
		require_once($sourcedir . DIRECTORY_SEPARATOR . 'Load.php');
		if(loadlanguage('ForumFirewall') === false)
      		loadLanguage('ForumFirewall'); }

	$string = '';
	if (!$modSettings['forumfirewall_enable']) return $string;

	if ((bool) ini_get('register_gobals')) {
		$string = $txt['forumfirewall_register_globals'];
		if (get_magic_quotes_gpc() || get_magic_quotes_runtime() || ((bool) ini_get('magic-quotes-sybase')))
			$string .= '<br />' . $txt['forumfirewall_magic_quotes'];
	} elseif (get_magic_quotes_gpc() || get_magic_quotes_runtime() || ((bool) ini_get('magic-quotes-sybase')))
			$string = $txt['forumfirewall_magic_quotes'];
	elseif (((bool) ini_get('allow_url_fopen')) || ((bool) ini_get('allow_url_include')))
			$string = $txt['forumfirewall_cheat_sheet'];
	return strtoupper($string);
}
// ref (OWASP A1)
function forumfirewall_my_utf8_decode($forumfirewall_conv_dta) {
return strtr($forumfirewall_conv_dta,
  "???????¥µÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝßàáâãäåæçèéêëìíîïðñòóôõöøùúûüýÿ",
  "SOZsozYYuAAAAAAACEEEEIIIIDNOOOOOOUUUUYsaaaaaaaceeeeiiiionoooooouuuuyy");
}
function forumfirewall_is_utf8($forumfirewall_conv_dta) {

	for ($i = 0, $len = strlen($forumfirewall_conv_dta); $i < $len; $i++) {
        $c = ord($forumfirewall_conv_dta[$i]);
        if ($c < 0x80) {
            if (($c > 0x1F && $c < 0x7F) || $c == 0x09 || $c == 0x0A || $c == 0x0D) continue; }
		if (($c & 0xE0) == 0xC0) $n = 1;
		elseif (($c & 0xF0) == 0xE0) $n = 2;
		elseif (($c & 0xF8) == 0xF0) $n = 3;
		elseif (($c & 0xFC) == 0xF8) $n = 4;
		elseif (($c & 0xFE) == 0xFC) $n = 5;
		else return false;
		for ($j = 0; $j < $n; $j++) {
			$i++;
			if ($i == $len || ((ord($forumfirewall_conv_dta[$i]) & 0xC0) != 0x80)) return false;
	}	}
    return true;
}
function forumfirewall_get_hash($stamp) {
	if ($stamp  % 2)
		$forumfirewall_algo = 'haval192,3'; //  was haval160,4 48-long > 34-long ok for ipv6 bin
	else
	$forumfirewall_algo = 'tiger192,4';  //  48-long > 34-long ok for ipv6 bin

	return $forumfirewall_algo;
}
function forumfirewall_cache_put_data($key, $value, $ttl = 20) {
	global $modSettings, $cache_hits, $cache_count, $db_show_debug, $ffcachedir;

	if (((int) $modSettings['forumfirewall_cache_duration']) < 20) return;
	
	$cache_count = isset($cache_count) ? $cache_count + 1 : 1;
	if (isset($db_show_debug) && $db_show_debug === true)
	{
		$cache_hits[$cache_count] = array('k' => $key, 'd' => 'put', 's' => $value === null ? 0 : strlen($value));
		$st = microtime();
	}

	$value = (empty($value) ? null : $value);
	$ff_filename = '';
	$ff_filename = $ffcachedir . DIRECTORY_SEPARATOR . 'ff_' . $key . '.php';

	// Custom cache?
	if (function_exists('fwrite')) {
		if ($value === null)
			@unlink($ff_filename);
		else {
			$cache_data = '';
 			$cache_data = '<' . '?' . 'php if (!defined(\'SMF\')) die; $ffallotted = \'' . (time() + $ttl) . '\'; $value = \'' . addcslashes($value, '\\\'') . '\'; ' . '?' . '>';

			// Write out the cache file, check that the cache write was successful; all the data must be written
			// If it fails due to low diskspace, or other, remove the cache file
			if (file_put_contents($ff_filename, $cache_data, LOCK_EX) !== strlen($cache_data))
				@unlink($ff_filename);
	}	}

	if (isset($db_show_debug) && $db_show_debug === true)
		$cache_hits[$cache_count]['t'] = array_sum(explode(' ', microtime())) - array_sum(explode(' ', $st));

	return;
}
function forumfirewall_cache_get_data($key, $ttl = 20) {
	global $modSettings, $cache_hits, $cache_count, $db_show_debug, $ffcachedir;

	if (((int) $modSettings['forumfirewall_cache_duration']) < 20) return '';

	$expired = true;
	$cache_count = isset($cache_count) ? $cache_count + 1 : 1;
	if (isset($db_show_debug) && $db_show_debug === true) {
		$cache_hits[$cache_count] = array('k' => $key, 'd' => 'get');
		$st = microtime();
	}

	$ff_filename = '';
	$ff_filename = $ffcachedir . DIRECTORY_SEPARATOR . 'ff_' . $key . '.php';

	// My cache!
	if (is_readable($ff_filename) && filesize($ff_filename) > 10) {
		@include($ff_filename);

		if (!isset($ffallotted) || empty($ffallotted)) $ffallotted = 0;
		if((int) $ffallotted > time())
			$expired = false;

		$ffallotted = null;

		if ((bool) $expired !== false && isset($value)) {
			@unlink($ff_filename);
			$value = null;

	}	}

	if (isset($db_show_debug) && $db_show_debug === true) {
		$cache_hits[$cache_count]['t'] = array_sum(explode(' ', microtime())) - array_sum(explode(' ', $st));
		$cache_hits[$cache_count]['s'] = isset($value) ? strlen($value) : 0;
	}

	if (empty($value))
		return null;
	// If it's broke, it's broke... so give up on it.
	else
		return $value;
}
function FFCopyright() {
	// The Copyright is required to remain.  It can only be removed if you provide a donation
	echo '<br /><div align="center"><span class="smalltext">Protected by: <a href="http://www.eastcoastrollingthunder.com" target="_blank" class="new_win">Forum Firewall &copy; 2010-2014</a></span></div>';
}
// Our log table structure - 
function forumfirewall_table_structure($name) {
	global $txt, $modSettings, $db_prefix, $smcFunc;

	db_extend('packages');

	return $smcFunc['db_table_structure']($db_prefix.'log_forumfirewall');
}

// Insert a new record modified for SMF 2.0 RC2
function forumfirewall_insert($forumfirewall_data, $result) {
	global $txt, $modSettings, $db_prefix, $smcFunc;

	if (empty($forumfirewall_data)) return;
	if (!is_array($forumfirewall_data)) return;
	if (empty($result)) return;

	$request = $headers = $forumfirewall_ip = $request_method = '';
	$request_uri = $server_protocol = $user_agent = $referer = '';

	$forumfirewall_ip = forumfirewall_ip2DB(forumfirewall_xss_safe($forumfirewall_data['visitor_ip']));

		$request_method = (empty($forumfirewall_data['request_method']) ? '' : forumfirewall_xss_safe($forumfirewall_data['request_method']));
	if (is_array($forumfirewall_data['request_entity'])) {
		foreach ($forumfirewall_data['request_entity'] as $h => $v) {
			$request_method .= $h . ": " .$v . "\n\r"; }
		unset($h, $v);
	}

	$request_uri = forumfirewall_xss_safe($forumfirewall_data['request_uri']);
	$server_protocol = forumfirewall_xss_safe($forumfirewall_data['server_protocol']);
	$user_agent = forumfirewall_xss_safe($forumfirewall_data['user_agent']);
	$referer = (isset($forumfirewall_data['referer']) ? forumfirewall_xss_safe($forumfirewall_data['referer']): '');

	$headers = "$request_method $request_uri $server_protocol\n";
	$headers .= "$user_agent\n";
	$headers .= "$referer\n";

	$date = time();  //  was date('Y-m-d H:i:s');

	$request = $smcFunc['db_insert']('insert',
		'{db_prefix}log_forumfirewall',
		array(
			'ip' => 'string',
			'date' => 'int',
			'http_headers' => 'string',
			'result' => 'string',
	         ),
		array(
			$forumfirewall_ip,
			(int) $date,
			$headers,
			$result,
		),
		array()
	);

	return $request;
}
function forumfirewall_insert_challenge($forumfirewall_data, $result) {
	global $txt, $modSettings, $db_prefix, $smcFunc;

	if (empty($forumfirewall_data)) return;
	if (!is_array($forumfirewall_data)) return;
	if (empty($result)) return;

	$forumfirewall_ip = '';
	$forumfirewall_ip = forumfirewall_ip2DB(forumfirewall_xss_safe($forumfirewall_data['visitor_ip']));

	$date = time(); //  was date('Y-m-d H:i:s');

	$request = $smcFunc['db_insert']('insert',
		'{db_prefix}log_ff_challenges',
		array(
			'ip' => 'string',
			'date' => 'int',
			'result' => 'string',
	         ),
		array(
			$forumfirewall_ip,
			(int) $date,
			$result,
		),
		array()
	);

	return $request;
}
//  New files
function forumfirewall_clear_cookie($ff_cvalue) {
	if (empty($ff_cvalue)) return null;
	setcookie('ff_token','', time()-2, '/');
	header('Expires: -1');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', false);
	header('Pragma: no-cache');
//	die();
}
function forumfirewall_set_cookie($ff_cvalue, $ff_cookie_time, $ff_level) {
	if (empty($ff_cvalue)) return null;

	$ff_cookie_adjust = (int) substr($ff_cookie_time ,-2);
	for ($j = 0;$j < (int) $ff_level;$j++){
		$ff_cookie_temp = '';
		for ($i = 0;$i<strlen($ff_cookie_adjust);$i++)
			$ff_cookie_temp .= ord(substr(strtoupper($ff_cookie_adjust), $i, 1));
		$ff_cookie_adjust = $ff_cookie_temp;
	}

	$ff_cookie_data = strlen($ff_level).$ff_level.$ff_cookie_adjust;
	$ff_cookie_temp = null;
	
	$ff_cookie_time = (int) $ff_cookie_time + 300;

	setcookie('ff_token', $ff_cookie_data, (int) $ff_cookie_time, '/');
	return;  //  $ff_cookie_data
}
function forumfirewall_get_random($ff_cvalue) {
	if (empty($ff_cvalue)) return null;
	$ff_value = $ff_count='';
	$ff_count=0;
	$ff_keys = array();

	mt_srand(forumfirewall_make_seed($ff_cvalue));
	while(count($ff_keys) < 2) {
	    $ff_value = mt_rand(1, 6);
	    if(!in_array($ff_value, $ff_keys))
	      $ff_keys[$ff_count] = $ff_value;$ff_count+=1;
	}

	$ff_value = $ff_count = null;
	return $ff_keys;
}
// PBKDF2 Implementation (described in RFC 2898)
// to stretch the hash function and make brute force difficult
function ff_pbkdf2($ff_pwd, $ff_hsalt, $ff_iterations = 5001, $ff_hlength = 64, $ff_hash_algo = 'sha512') {

	if(empty($ff_pwd) || empty($ff_hsalt)) return null;

	$ff_hash_length = strlen(hash($ff_hash_algo, null, true));
	$ff_key_blocks = ceil($ff_hlength / $ff_hash_length);
	$ff_derived_key = '';
	$ff_res = $ff_block = '';

	for ($ff_block = 1; $ff_block <= (int) $ff_key_blocks; $ff_block ++) {
		$ff_res = hash_hmac($ff_hash_algo, $ff_hsalt . pack('N', $ff_block), $ff_pwd, true);
		for ($i = 1; $i < $ff_iterations; $i ++)
			$ff_res ^= ($ff_block = hash_hmac($ff_hash_algo, $ff_block, $ff_pwd, true));
		$ff_derived_key .= $ff_res;
	}
	$ff_res = null;
	return substr($ff_derived_key, 0, $ff_hlength);
}
function forumfirewall_load_image($ff_image_txt) {
	if (empty($ff_image_txt)) return null;

	global $settings;

	// Is this GD2? Needed for pixel size.  Function_exists is all that is reqd per 18: drupal-2161955-18-gd-remove-get_extension_func-D7.patch
	$gd2 = function_exists('imagecreatetruecolor');

	// font size
	$ff_fnt_size = ($gd2 ? 18 : 24);  // ratio 24/18  was 10.5 : 14;

	$ff_font_dir = dir($settings['default_theme_dir'] . DIRECTORY_SEPARATOR . 'fonts');
	$ff_ttfont_list = array();

	while ($entry = $ff_font_dir->read()) {
		if (preg_match('~^(.+)\.ttf$~', $entry, $matches) === 1)
			$ff_ttfont_list[] = $entry;
	}

	// Try use Screenge if we can - it looks good!
	if (in_array('Screenge.ttf', $ff_ttfont_list))
		$ff_ttfont_list = array('Screenge.ttf');
	else
		$ff_ttfont_list = empty($ff_ttfont_list) ? array() : array($ff_ttfont_list[mt_rand(0, count($ff_ttfont_list) - 1)]);

	if (empty($ff_ttfont_list)) return false;

	$ff_img_fnt = $settings['default_theme_dir'] . DIRECTORY_SEPARATOR . 'fonts' .DIRECTORY_SEPARATOR . $ff_ttfont_list[0];

	// determine numeric center of image
	$ff_img_size = ImageTTFBBox($ff_fnt_size, 0, $ff_img_fnt, $ff_image_txt);
	$ff_x = abs($ff_img_size[0]) + abs($ff_img_size[2]);
	$ff_y = abs($ff_img_size[5]) + abs($ff_img_size[1]);

	// Create an image.
	$ff_img_res = ($gd2 ? imagecreatetruecolor($ff_x, $ff_y) : imagecreate($ff_x, $ff_y));

	// Draw image background
	$ff_bg_color = imagecolorallocate($ff_img_res, 255, 255, 255);
	imagefilledrectangle($ff_img_res, 0, 0, $ff_x - 1, $ff_y - 1, $ff_bg_color);

	// Color the text black
	$ff_char_color = imagecolorallocate($ff_img_res, 0, 0, 0);

	//add text to image 
	imagettftext($ff_img_res, $ff_fnt_size, 0, abs($ff_img_size[0]),
		abs($ff_img_size[5]), $ff_char_color, $ff_img_fnt, $ff_image_txt);

	if (empty($ff_img_res)) return false;

    ob_start();
	if (function_exists('imagejpeg')) imagejpeg($ff_img_res, null, 90);
	elseif (function_exists('imagepng')) imagepng($ff_img_res);
	else imagegif($ff_img_res);
	imagedestroy($ff_img_res);
	if (function_exists('ob_get_clean'))
		$ff_captured_image = ob_get_clean();
	else {
		$ff_captured_image = ob_get_contents();
		ob_end_clean();
	}

	$ff_captured_img_cpt = base64_encode($ff_captured_image);
	$ff_img_src= "data:image/" . ((function_exists('imagejpeg')) ? "jpeg":((function_exists('imagepng'))? "png":"gif")) . ";base64," . $ff_captured_img_cpt;

	$ff_img_fnt = $ff_captured_image = $ff_captured_img_cpt = null;

	return $ff_img_src;
}
function forumfirewall_IPv4orIPv6($forumfirewall_ip) {
	if (@version_compare(PHP_VERSION, '5.2.0') != -1) {
    	if (filter_var($forumfirewall_ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) !== false)
       		return true;
	} else {
		if (strpos($forumfirewall_ip, ':') !== false)
			return true;
	}
	return false;
}
// Divides ipv6 address into address and a prefix length parts
function forumfirewall_divide($forumfirewall_ip) {

	$ff_bitmask = '';

	if(strrpos($forumfirewall_ip, '/') !== false) {
		$ff_elements = array();
		$ff_elements = explode('/', $forumfirewall_ip);
		if(count($ff_elements) === 2) {
			$forumfirewall_ip = $ff_elements[0];
			$ff_bitmask = $ff_elements[1];
		}
		//  unset($ff_elements);  //  Assume small arrray
	}
	return array($forumfirewall_ip, $ff_bitmask);
}
// Returns ipv6 and ipv4 parts
function forumfirewall_return64($forumfirewall_ip, $ff_uncom = true) {

	$ff_ipPart = array();
	$pos = 0;

	$forumfirewall_ip = forumfirewall_noMask($forumfirewall_ip);

	if ($ff_uncom !== false)
		$forumfirewall_ip = forumfirewall_uncomip6($forumfirewall_ip);

	if (strstr($forumfirewall_ip, '.') !== false) {
		$pos = (int) strrpos($forumfirewall_ip, ':');
   		$forumfirewall_ip{$pos} = '_';
            $ff_ipPart = explode('_', $forumfirewall_ip);
            return $ff_ipPart;
        }

	return array($forumfirewall_ip, '');
}
//  Retuirns only ipv6 netmask spec
function forumfirewall_mask($forumfirewall_ip) {

	$ff_elements = forumfirewall_divide($forumfirewall_ip);

	return $ff_elements[1];
}
//  Deletes ipv6 prefix length and netmask
function forumfirewall_noMask($forumfirewall_ip) {

	$ff_elements = forumfirewall_divide($forumfirewall_ip);

	return $ff_elements[0];
}
//  Returns uncompressed ipv6 in hex format
function forumfirewall_uncomip6($forumfirewall_ip, $ff_leadingZeros = false) {

	if ($forumfirewall_ip == '') return '';

	$ff_prefix = $ff_ipa = $ff_ipb = $forumfirewall_mask = $fill = '';
	$ff_counta = $ff_countb = -1;
	$pos = 0;
	$ff_elements = array();

	$forumfirewall_mask = forumfirewall_mask($forumfirewall_ip);
	$forumfirewall_ip = forumfirewall_noMask($forumfirewall_ip);

 	if (strpos($forumfirewall_ip, '::') !== false) {
 		list($ff_ipa, $ff_ipb) = explode('::', $forumfirewall_ip);
		if ($ff_ipa == '')
 			$ff_counta = -1;
		else {
			$pos = 0;
			if ((int) ($pos = substr_count($ff_ipa, ':')) > 0) {
				$ff_counta = $pos;
			} else
				$ff_counta = 0;
		}

		if ($ff_ipb == '')
  			$ff_countb = -1;
		else {
			$pos = 0;
			if ((int) ($pos = substr_count($ff_ipb, ':')) > 0) {
				$ff_countb = $pos;
			} else
				$ff_countb = 0;
		}

		if (strpos($ff_ipb, '.') !== false)
			$ff_countb++;

		if ((int) $ff_counta == -1 && (int) $ff_countb == -1)  // ::
			$forumfirewall_ip = '0:0:0:0:0:0:0:0';
		else if ((int) $ff_counta == -1) {  // ::xxx
			$fill = str_repeat('0:', (7 - (int) $ff_countb));
			$forumfirewall_ip  = str_replace('::', $fill, $forumfirewall_ip);
		} else if ((int) $ff_countb == -1) {  // xxx::
			$fill = str_repeat(':0', (7 - (int) $ff_counta));
			$forumfirewall_ip  = str_replace('::', $fill, $forumfirewall_ip);
		} else {  // xxx::xxx
			$fill = str_repeat(':0:', (6 - (int) $ff_countb - (int) $ff_counta));
			$forumfirewall_ip  = str_replace('::', $fill, $forumfirewall_ip);
			$forumfirewall_ip  = str_replace('::', ':', $forumfirewall_ip);
	}	}

	if($ff_leadingZeros !== false) {
		$forumfirewall_ipT = $forumfirewall_ipart = array();
		$forumfirewall_ipart = explode(':', $forumfirewall_ip);
		foreach($forumfirewall_ipart as $forumfirewall_iparts) {
			$forumfirewall_ipT[] = sprintf('%04s', $forumfirewall_iparts);
 		}
		unset($forumfirewall_iparts);
		$forumfirewall_ip = implode(':', $forumfirewall_ipT);
		unset($forumfirewall_ipart);
	}

	if ($forumfirewall_mask !== '')
		$forumfirewall_ip = $forumfirewall_ip.'/'.$forumfirewall_mask;

	return $forumfirewall_ip;
}
// Returns compressed hex format ipv6 
function forumfirewall_compressip6($forumfirewall_ip, $ff_force = false)  {

	$forumfirewall_mask = $forumfirewall_mask = $ff_compip = $match = '';
	$forumfirewall_ips = array();

	$forumfirewall_mask = forumfirewall_mask($forumfirewall_ip);
	if(strpos($forumfirewall_ip, '::') !== false) { // is_compressed
		if($ff_force !== false)
			$forumfirewall_ip = forumfirewall_uncomip6($forumfirewall_ip). (($forumfirewall_mask != '') ? '/'.$forumfirewall_mask : ''); 
		else
			return $forumfirewall_ip;
	}

	$forumfirewall_ip = forumfirewall_noMask($forumfirewall_ip);
		$forumfirewall_ips = explode(':', $forumfirewall_ip);
		for ($i = 0; $i < count($forumfirewall_ips); $i++) {
			$forumfirewall_ips[$i] = base_convert((ff_hexdec($forumfirewall_ips[$i])), 10, 16);
			//  64 bit compatibility attempt was $forumfirewall_ips[$i] = dechex(hexdec($forumfirewall_ips[$i]));
		}

	$ff_compip = ':' . implode(':', $forumfirewall_ips) . ':';
	preg_match_all('/(:0)(:0)+/', $ff_compip, $ff_zero);
	if ((int) count($ff_zero[0]) > 0) {
		$match = '';
		foreach ($ff_zero[0] as $ff_zeros) {
			if (strlen($ff_zeros) > strlen($match))
				$match = $ff_zeros;

		unset($ff_zeros);
		}
	$ff_compip = preg_replace('/' . $match . '/', ':', $ff_compip, 1);
	}

	$ff_compip = preg_replace('/((^:)|(:$))/', '', $ff_compip);
	$ff_compip = preg_replace('/((^:)|(:$))/', '::', $ff_compip);

	if ($forumfirewall_mask != '') {
		if ($ff_compip == null) $ff_compip = '::';  //  RFC 2373
		$ff_compip = $ff_compip.'/'.$forumfirewall_mask;
		$forumfirewall_mask = null;  //  no duplicate masks
	}

	unset($forumfirewall_ips);

	if ($ff_compip == null) $ff_compip = '::'; //  RFC 2373
	$ff_compip = $ff_compip.(($forumfirewall_mask != '') ? '/'.$forumfirewall_mask : '');

	// RFC5952 4.2.2
	// The symbol "::" MUST NOT be used to shorten just one
	// 16-bit 0 field.
	if ((substr_count($ff_compip, ':') == 7) && (strpos($ff_compip, '::') !== false))
		$ff_compip = str_replace('::', ':0:', $ff_compip);

	return $ff_compip;
}
//  IP address to binary
function forumfirewall_ip2Bin($forumfirewall_ip) {

	$forumfirewall_ipBin = '';
	$forumfirewall_unpack = array();
	if(forumfirewall_IPv4orIPv6($forumfirewall_ip) === false)
		return sprintf('%032b', ip2long($forumfirewall_ip));

    if(($forumfirewall_unpack = forumfirewall_dtr_pton($forumfirewall_ip)) === false) return false;
    $bits = 15; // 16 x 8 bit = 128bit ip6
    while ((int) $bits >= 0) {
        $forumfirewall_bin = sprintf('%08b',(ord($forumfirewall_unpack[(int) $bits])));
        $forumfirewall_ipBin = $forumfirewall_bin.$forumfirewall_ipBin;
        $bits--;
    }
    return $forumfirewall_ipBin;
}
// Converts a printable IP into an unpacked binary string ref http://www.highonphp.com/tag/inet_pton
function forumfirewall_dtr_pton($forumfirewall_ip) {

	if ($forumfirewall_ip == '') $forumfirewall_ip = '0.0.0.0';

	$ff_in_addr = array();
	$ff_in_addr = forumfirewall_inet_pton($forumfirewall_ip);
	$ff_strlen = strlen($ff_in_addr);

	if(((int) $ff_strlen == 16) || ((int) $ff_strlen == 4)) {
		return current(unpack('A'.(int) $ff_strlen, $ff_in_addr));
	} else //  ff_strlen = 32
		return str_pad(decbin(ip2long($forumfirewall_ip)), 32, '0', STR_PAD_LEFT);

    return false;
}
// Converts a human readable IP address to its packed in_addr representation  ref http://php.net/inet_pton
function forumfirewall_inet_pton($forumfirewall_ip) {
	// IPv4 (or IPv4-compat, or IPv4-mapped)
	if(preg_match('/(^|:)([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$/i', $forumfirewall_ip, $ff_matches) === 1) {
		for($i = count($ff_matches); $i-- > 2; ) {
			if($ff_matches[$i] > 255 || ($ff_matches[$i][0] === '0' && strlen($ff_matches[$i]) > 1)) {
				$forumfirewall_ip = false;  //  This already failed
		}	}
		if(empty($ff_matches[1])) {
			$ff_in_addr = '';
			$ff_in_addr = ip2long($forumfirewall_ip);
			if($ff_in_addr !== false) {
				//  unset($ff_matches);  //  Array assumed small
				return pack('N', $ff_in_addr);
			} else
				$forumfirewall_ip = false;  //  This already failed
		}
		$ff_suffix = sprintf('%02x%02x:%02x%02x', $ff_matches[2], $ff_matches[3], $ff_matches[4], $ff_matches[5]);
		$forumfirewall_ip = substr_replace($forumfirewall_ip, $ff_matches[1] . $ff_suffix, strrpos($forumfirewall_ip, $ff_matches[0]));
	}  // IPv6 half
	if(forumfirewall_IPv4orIPv6($forumfirewall_ip) === false ||
		strspn($forumfirewall_ip, '01234567890abcdefABCDEF:') !== strlen($forumfirewall_ip)) {
		$forumfirewall_ip = false;  //  This already failed
	}

	//  if the first or last 2 chars are :: then add 0
	if(substr($forumfirewall_ip, 0, 2) == '::')
		$forumfirewall_ip = '0'.$forumfirewall_ip;

	if(substr($forumfirewall_ip, -2)  == '::')
		$forumfirewall_ip .= '0';

	$ff_in_addr = array();
	$ff_in_addr = explode(':', $forumfirewall_ip);
	$ff_count = count($ff_in_addr);

	// grouped zeros
	if((strpos($forumfirewall_ip, '::') !== false) && ((int) $ff_count < 8)) {
		$zeroGroup = array_search('', $ff_in_addr, 1);
		if($zeroGroup !== null) {
			// we're replacing this cell, so we splice (8 - $ff_count + 1) cells containing '0'
			array_splice($ff_in_addr, (int) $zeroGroup, 1, array_fill(0, 9 - (int) $ff_count, '0'));
		} else
			$forumfirewall_ip = false;  //  This already failed
	}

	// guard against excessive ':' or '::'
	if((int) $ff_count > 8 || array_search('', $ff_in_addr, 1) !== false)
		$forumfirewall_ip = false;  //  This already failed


	// leading zeros
	foreach($ff_in_addr as $ff_v) {
		if(strlen(ltrim($ff_v, '0')) > 4) {
			unset($ff_v);
			$forumfirewall_ip = false;  //  This already failed
	}	}

	//  was $ff_in_addr = array_map('hexdec', $ff_in_addr);
	$ff_in_addr = array_map('ff_hexdec', $ff_in_addr);
	array_unshift($ff_in_addr, 'n*');
	$ff_in_addr = call_user_func_array('pack', $ff_in_addr);
	unset($ff_v);

	return $ff_in_addr;
}
function ff_hexdec($ff_val) {  // 64 bit compatible attempt
	return (float) base_convert($ff_val, 16, 10);
}

//  Clean and prepare an IP to be saved to DB
function forumfirewall_ip2DB($forumfirewall_ip) {
	if ($forumfirewall_ip == '') $forumfirewall_ip = '0.0.0.0';
	$forumfirewall_ipBin = '';

	$forumfirewall_ip = strtolower($forumfirewall_ip);  //  Keep them all the same
	if (forumfirewall_IPv4orIPv6($forumfirewall_ip) !== false) {
		$forumfirewall_ipPart = array();

		// Remove emptys
		if (strpos($forumfirewall_ip, '::') !== false)
			$forumfirewall_ip = forumfirewall_uncomip6($forumfirewall_ip); 

		// Remove ipv6 component
		$forumfirewall_ipPart = forumfirewall_return64($forumfirewall_ip);
		if (!empty($forumfirewall_ipPart[1]))
			$forumfirewall_ip = $forumfirewall_ipPart[1];

		//  unset($forumfirewall_ipPart);  array assumed small
	}

	$forumfirewall_ipBin = forumfirewall_dtr_pton($forumfirewall_ip);

	return $forumfirewall_ipBin;
}
function forumfirewall_array_flatten($ff_array, $newff_array = array()) {
	if(empty($ff_array) || !is_array($ff_array)) return null;

	if (@version_compare(PHP_VERSION, '5.1.0') != -1) {
		$newff_array = new RecursiveIteratorIterator(new RecursiveArrayIterator($ff_array));
		$newff_array = iterator_to_array($newff_array, false);
	} else {
		foreach ($ff_array as $key => $child) {
			if (is_array($child))
				$newff_array =& array_flatten($child, $newff_array);
			elseif (is_string($key) > 1)
				$newff_array[$key] = $child;
			else
				$newff_array[] = $child;
		}
		unset($key, $child);
	}
	return $newff_array;
}
?>